Package com.datecs.fiscalprinter.SDK.model.BGR

# Class WP50_BGR

java.lang.Object
com.datecs.fiscalprinter.SDK.FiscalDeviceV1
com.datecs.fiscalprinter.SDK.model.BGR.WP50_BGR

    public class WP50_BGR
    extends FiscalDeviceV1

- ## Field Summary

  ### Fields inherited from class com.datecs.fiscalprinter.SDK.FiscalDeviceV1

  `MAX_ADDITIONAL_PAYMENTS, transport`

- ## Constructor Summary

  Constructors
  Constructor | Description
  --- | ---
  `WP50_BGR​(AbstractTransportProtocol protocol)` |
  `WP50_BGR​(java.io.InputStream in, java.io.OutputStream out)` |

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `FiscalResponse` | `command100Variant0Version0​(java.lang.String text)` | (100) DISPLAY TEXT ON THE CUSTOMER DISPLAY
  `FiscalResponse` | `command101Variant0Version0​(java.lang.String operatorCode, java.lang.String oldPassword, java.lang.String newPassword)` | 65h (101) SET OPERATOR PASSWORD
  `FiscalResponse` | `command102Variant0Version0​(java.lang.String operatorCode, java.lang.String operatorPass, java.lang.String operatorName)` | 66h (102) SET OPERATOR NAME
  `FiscalResponse` | `command103Variant0Version0()` | 67h (103) CURRENT RECEIPT INFORMATION
  `FiscalResponse` | `command105Variant0Version0()` | 69h (105) OPERATORS REPORT
  `FiscalResponse` | `command106Variant0Version0​(java.lang.String mSec)` | 6Ah (106) OPENING A DRAWER
  `FiscalResponse` | `command107Variant0Version0()` | 6Bh (107) DEFINING AND READING ARTICLES (PLU) Information about the items
  `FiscalResponse` | `command107Variant10Version0()` | 6Bh (107) DEFINING AND READING ARTICLES (PLU) Return data for the next found item with sales on it.
  `FiscalResponse` | `command107Variant11Version0​(java.lang.String option, java.lang.String startPLU)` | 6Bh (107) DEFINING AND READING ARTICLES Find a free (unprogrammed) item.
  `FiscalResponse` | `command107Variant12Version0​(java.lang.String PLU, java.lang.String price)` | 6Bh (107) DEFINING AND READING ARTICLES Set the price of an item
  `FiscalResponse` | `command107Variant1Version0​(java.lang.String taxGr, java.lang.String PLU, java.lang.String group, java.lang.String price, java.lang.String replaceQty, java.lang.String quantity, java.lang.String name)` | 6Bh (107) DEFINING AND READING ARTICLES (PLU)
  `FiscalResponse` | `command107Variant2Version0​(java.lang.String PLU, java.lang.String quantity)` | 6Bh (107) DEFINING AND READING ARTICLES (PLU) Change the available quantity for an item.
  `FiscalResponse` | `command107Variant3Version0​(java.lang.String option, java.lang.String PLU, java.lang.String toPLU)` | 6Bh (107) DEFINING AND READING ARTICLES (PLU) Delete an item.
  `FiscalResponse` | `command107Variant4Version0​(java.lang.String PLU)` | 6Bh (107) DEFINING AND READING ARTICLES (PLU) Read item data.
  `FiscalResponse` | `command107Variant5Version0​(java.lang.String startPLU)` | 6Bh (107) DEFINING AND READING ARTICLES (PLU) Return data for the first programmed item or FTT found.
  `FiscalResponse` | `command107Variant6Version0​(java.lang.String lastPLU)` | 6Bh (107) DEFINING AND READING ARTICLES (PLU) Return the data for the last found programmed item.
  `FiscalResponse` | `command107Variant7Version0()` | 6Bh (107) DEFINING AND READING ARTICLES (PLU) Return the data for the next found programmed item
  `FiscalResponse` | `command107Variant8Version0​(java.lang.String startPLU)` | 6Bh (107) DEFINING AND READING ARTICLES (PLU) Return the data for the first found item with sales on it
  `FiscalResponse` | `command107Variant9Version0​(java.lang.String startPLU)` | 6Bh (107) DEFINING AND READING ARTICLES (PLU) Return data for the last found item with sales on it.
  `FiscalResponse` | `command108Variant0Version0​(java.lang.String option)` | 6Ch (108) EXTENDED DAILY FINANCIAL REPORT The command has the same syntax as command 69 (45H), * but at the beginning of the daily report a report of * items for which there are sales for the day.
  `FiscalResponse` | `command109Variant0Version0​(java.lang.String count)` | 6Dh (109) DUPLICATE RECEIPT PRINT
  `FiscalResponse` | `command110Variant0Version0()` | 6Eh (110) ADDITIONAL INFORMATION FOR THE DAY
  `FiscalResponse` | `command111Variant0Version0​(java.lang.String reportType, java.lang.String firstPLU, java.lang.String lastPLU, java.lang.String group)` | 6Fh (111) ARTICLE (PLU) REPORT
  `FiscalResponse` | `command112Variant0Version0​(java.lang.String operator)` | 70h (112) RECEIVING OPERATOR INFORMATION
  `FiscalResponse` | `command112Variant1Version0​(java.lang.String operator)` | 70h (112) RECEIVING OPERATOR INFORMATION - Reversal (storno) information.
  `FiscalResponse` | `command113Variant0Version0()` | 71h (113) READ NUMBER OF THE LAST PRINTED DOCUMENT
  `FiscalResponse` | `command114Variant0Version0​(java.lang.String Rec1)` | 72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Information about the active tax rates for the specified Z-report record.
  `FiscalResponse` | `command114Variant10Version0​(java.lang.String closure1)` | 72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Information on the total turnover and VAT up to the specified Z-report
  `FiscalResponse` | `command114Variant1Version0​(java.lang.String closure1, java.lang.String closure2)` | 72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Turnover information for the specified record or period.
  `FiscalResponse` | `command114Variant2Version0​(java.lang.String closure1, java.lang.String closure2)` | 72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Information on net amounts for the specified record or period.
  `FiscalResponse` | `command114Variant3Version0​(java.lang.String closure1, java.lang.String closure2)` | 72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Information on the charged VAT for the specified record or period.
  `FiscalResponse` | `command114Variant4Version0​(java.lang.String closure1)` | 72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Additional information about the specified entry.
  `FiscalResponse` | `command114Variant5Version0​(java.lang.String closure1)` | 72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Information about the specified entry from the fiscal memory for setting tax rates
  `FiscalResponse` | `command114Variant6Version0​(java.lang.String closure1)` | 72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Information about the specified FM record with RAM reset.
  `FiscalResponse` | `command114Variant7Version0​(java.lang.String closure1, java.lang.String closure2)` | 72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Information about the amounts by type of payment for the specified record or period
  `FiscalResponse` | `command114Variant8Version0​(java.lang.String closure1, java.lang.String closure2)` | 72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Information about the amounts by type of payment for the specified record or period.
  `FiscalResponse` | `command114Variant9Version0​(java.lang.String closure1, java.lang.String closure2)` | 72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Information about the amounts by type of payment for the specified record or period.
  `FiscalResponse` | `command115Variant0Version0​(java.lang.String rowNum, java.lang.String data)` | 73h (115) GRAPHIC LOGO PROGRAMMING
  `FiscalResponse` | `command115Variant1Version0​(java.lang.String rowNum)` | 73h (115) READING A GRAPHIC LOGO
  `FiscalResponse` | `command117Variant0Version0​(java.lang.String Reset)` | 75h (117) DAILY FINANCIAL STATEMENT WITH PRINT OF DATA BY DEPARTMENT
  `FiscalResponse` | `command118Variant0Version0​(java.lang.String Reset)` | 76h (118) DAILY FINANCIAL REPORT WITH DEPARTMENT AND PLU PRINTING
  `FiscalResponse` | `command119Variant0Version0​(java.lang.String Flg, java.lang.String DT1, java.lang.String DT2)` | 77h (119) WORK WITH ELECTRONIC JOURNAL Read data Returns the first line of a document with date and time DT1 and sets the end of the search for a document with date and time DT2 (inclusive).
  `FiscalResponse` | `command119Variant1Version0()` | 77h (119) EJ OPERATION Reading the next text line by EJ.
  `FiscalResponse` | `command124Variant0Version0​(java.lang.String DocType, java.lang.String BegDate, java.lang.String EndDate)` | 7Ch (124) READING EJ Search EJ by date and time.
  `FiscalResponse` | `command124Variant1Version0​(java.lang.String DocType, java.lang.String BegZ, java.lang.String EndZ)` | 7Ch (124) EJ READING - Search EJ by Z report number.
  `FiscalResponse` | `command124Variant2Version0()` | 7Ch (124) READING A EJ Information about EJ
  `FiscalResponse` | `command125Variant0Version0​(java.lang.String DocNum, java.lang.String RecType)` | 7Dh (125) READING DOCUMENT DATA BY NUMBER Preparation of the document for reading.
  `FiscalResponse` | `command125Variant1Version0()` | 7Dh (125) READING DOCUMENT DATA BY NUMBER
  `FiscalResponse` | `command125Variant1Version2()` | 7Dh (125) READING DOCUMENT DATA BY NUMBER
  `FiscalResponse` | `command125Variant2Version0​(java.lang.String DocNum, java.lang.String RecType)` | 7Dh (125) READING DOCUMENT DATA BY NUMBER Reading the next line with structures * 7Dh (125) READING DATA FROM A DOCUMENT BY NUMBER - Print the document in text on paper
  `FiscalResponse` | `command140Variant0Version0​(java.lang.String EIK, java.lang.String EIKType, java.lang.String Receiver, java.lang.String Client, java.lang.String TaxNo, java.lang.String Address_1, java.lang.String Address_2)` | 8Ch (140) STORAGE OF THE CLIENT'S DATA IN THE MEMORY OF FD Recording / changing customer data according to UIC.
  `FiscalResponse` | `command140Variant1Version0​(java.lang.String EIK)` | 8Ch (140) STORAGE OF THE CLIENT'S DATA IN THE MEMORY OF FD Deletion of EIK(UIC) customer data.
  `FiscalResponse` | `command140Variant2Version0​(java.lang.String Seller)` | 8Ch (140) STORAGE OF THE CLIENT'S DATA IN THE MEMORY OF FD Record data for seller's name.
  `FiscalResponse` | `command140Variant3Version0()` | 8Ch (140) STORAGE OF THE CLIENT'S DATA IN THE MEMORY OF FD Read the seller's name field.
  `FiscalResponse` | `command140Variant4Version0()` | 8Ch (140) STORAGE OF THE CLIENT'S DATA IN THE MEMORY OF FD Read data for the first client stored in the device's memory.
  `FiscalResponse` | `command140Variant5Version0()` | 8Ch (140) STORAGE OF THE CLIENT'S DATA IN THE MEMORY OF FD Read data for the next client stored in the device's memory.
  `FiscalResponse` | `command140Variant6Version0()` | 8Ch (140) STORAGE OF THE CLIENT'S DATA IN THE MEMORY OF FD Delete data for all clients stored in the device's memory.
  `FiscalResponse` | `command140Variant7Version0​(java.lang.String EIK)` | 8Ch (140) STORAGE OF THE CLIENT'S DATA IN THE MEMORY OF FD Read customer data by EIK (UIC).
  `FiscalResponse` | `command33Variant0Version0()` | 21H (33) CLEARING THE DISPLAY
  `FiscalResponse` | `command35Variant0Version0​(java.lang.String text)` | 23H (35) DISPLAY OF TEXT IN THE BOTTOM ROW OF THE DISPLAY
  `FiscalResponse` | `command38Variant0Version0()` | 26H (38) OPENING OF NON FISCAL RECEIPT
  `FiscalResponse` | `command39Variant0Version0()` | 27h (39) CLOSURE OF NON FISCAL RECEIPT
  `FiscalResponse` | `command42Variant0Version0​(java.lang.String text)` | 2Ah (42) FREE TEXT PRINTING IN OFFICE RECEIPT
  `FiscalResponse` | `command42Variant1Version0​(java.lang.String Height, java.lang.String Text)` | 2Ah (42) FREE TEXT PRINTING IN OFFICE RECEIPT
  `FiscalResponse` | `command43Variant0Version0​(java.lang.String itemIndex, java.lang.String itemText)` | 2Bh (43) WRITE HEADER AND FOOTER
  `FiscalResponse` | `command43Variant1Version0​(java.lang.String printOption, java.lang.String value)` | 2Bh (43) PRINT OPTIONS
  `FiscalResponse` | `command43Variant2Version0​(java.lang.String itemOption)` | 2Bh (43) PRINTING - READING OPTIONS
  `FiscalResponse` | `command43Variant2Version1​(java.lang.String lineNumber)` | 2Bh (43) PRINTING - READING OPTIONS Reading clichÃ©s
  `FiscalResponse` | `command44Variant0Version0​(java.lang.String lines)` | 2Ch (44) FEED THE PAPER
  `FiscalResponse` | `command46Variant0Version0​(java.lang.String OpCode, java.lang.String OpPwd, java.lang.String NSale, java.lang.String TillNmb, java.lang.String DocType, java.lang.String DocNumber, java.lang.String DocDateTime, java.lang.String FMNumber, java.lang.String Invoice, java.lang.String InvNumber, java.lang.String Reason)` | 2E (46) ISSUE OF A REFUND RECEIPT (STORNO)
  `FiscalResponse` | `command47Variant0Version0​(java.lang.String text)` | 2Fh (47) DISPLAY OF TEXT ON THE TOP OF THE DISPLAY
  `FiscalResponse` | `command48Variant0Version0​(java.lang.String OpNum, java.lang.String Password, java.lang.String TillNum, java.lang.String NSale)` | 30h (48) OPENING OF A FISCAL (CUSTOMER) RECEIPT
  `FiscalResponse` | `command48Variant1Version0​(java.lang.String OpCode, java.lang.String OpPwd, java.lang.String TillNmb, java.lang.String NSale)` | 30h (48) OPENING OF A FISCAL (CUSTOMER) RECEIPT -extended customer invoice
  `FiscalResponse` | `command48Variant2Version0()` | 30h (48) Serial number of the sale by the LPG of the last issued fiscal / cancellation receipt.
  `FiscalResponse` | `command49Variant0Version0​(java.lang.String L1, java.lang.String L2, java.lang.String taxCd, java.lang.String price, java.lang.String quan, java.lang.String perc)` | 31h (49) REGISTRATION (SALE) OF ITEM
  `FiscalResponse` | `command49Variant0Version1​(java.lang.String L1, java.lang.String L2, java.lang.String Dept, java.lang.String price, java.lang.String quan, java.lang.String perc)` | 31h (49) REGISTRATION (SALE) OF ITEM Percentage surcharge / discount
  `FiscalResponse` | `command49Variant1Version0​(java.lang.String L1, java.lang.String L2, java.lang.String taxCd, java.lang.String price, java.lang.String quan, java.lang.String absSum)` | 31h (49) REGISTRATION (SALE) OF ITEM surcharge / discount by value
  `FiscalResponse` | `command49Variant1Version1​(java.lang.String L1, java.lang.String L2, java.lang.String Dept, java.lang.String price, java.lang.String quan, java.lang.String absSum)` | 31h (49) REGISTRATION (SALE) OF ITEM surcharge / discount by value
  `FiscalResponse` | `command50Variant0Version0​(java.lang.String startDate, java.lang.String endDate)` | 32h (50) TAX RATES DURING THE RELEVANT PERIOD Returns the values that were set during the time period
  `FiscalResponse` | `command51Variant0Version0​(java.lang.String print, java.lang.String display)` | 33h (51) SUBTOTAL
  `FiscalResponse` | `command51Variant1Version0​(java.lang.String print, java.lang.String display, java.lang.String perc)` | 33h (51) SUBTOTAL With a percentage discount / surcharge
  `FiscalResponse` | `command51Variant2Version0​(java.lang.String print, java.lang.String display, java.lang.String absSum)` | 33h (51) SUBTOTAL Discount / surcharge in absolute value
  `FiscalResponse` | `command52Variant0Version0​(java.lang.String L1, java.lang.String taxCd, java.lang.String price, java.lang.String quan, java.lang.String UN, java.lang.String perc)` | 34h (52) REGISTRATION AND DISPLAY Percentage increase / discount
  `FiscalResponse` | `command52Variant0Version1​(java.lang.String L1, java.lang.String Dept, java.lang.String price, java.lang.String quan, java.lang.String perc)` | 34h (52) REGISTRATION AND DISPLAY Percentage surcharge / discount
  `FiscalResponse` | `command52Variant1Version0​(java.lang.String L1, java.lang.String taxCd, java.lang.String price, java.lang.String quan, java.lang.String absSum)` | 34h (52) REGISTRATION AND DISPLAY surcharge / discount on value
  `FiscalResponse` | `command52Variant1Version1​(java.lang.String L1, java.lang.String Dept, java.lang.String price, java.lang.String quan, java.lang.String absSum)` | 34h (52) REGISTRATION AND DISPLAY surcharge / discount by value
  `FiscalResponse` | `command53Variant0Version0​(java.lang.String L1, java.lang.String L2, java.lang.String paidMode, java.lang.String amount)` | 35h (53) CALCULATION OF TOTAL
  `FiscalResponse` | `command54Variant0Version0​(java.lang.String text)` | 36h (54) PRINTING FISCAL FREE TEXT
  `FiscalResponse` | `command56Variant0Version0()` | 38h (56) CLOSING (CLOSING) OF A FISCAL RECEIPT
  `FiscalResponse` | `command57Variant0Version0​(java.lang.String Bulstat, java.lang.String seller, java.lang.String receiver, java.lang.String client, java.lang.String taxNo, java.lang.String address)` | 39h (57) PRINT OF CUSTOMER INFORMATION
  `FiscalResponse` | `command57Variant1Version0​(java.lang.String typeEIK, java.lang.String EIK, java.lang.String seller, java.lang.String receiver, java.lang.String client, java.lang.String taxNo, java.lang.String address)` | 39h (57) PRINT OF CUSTOMER INFORMATION
  `FiscalResponse` | `command58Variant0Version0​(java.lang.String display, java.lang.String plu, java.lang.String dept, java.lang.String quan, java.lang.String perc)` | 3Ah (58) REGISTRATION (SALE) OF PROGRAMMED ITEM (PLU) Percentage surcharge or discount
  `FiscalResponse` | `command58Variant0Version1​(java.lang.String D, java.lang.String plu, java.lang.String dept, java.lang.String quan, java.lang.String abs)` | 3Ah (58) REGISTRATION (SALE) OF PROGRAMMED ITEM (PLU) surcharge or discount by value
  `FiscalResponse` | `command60Variant0Version0()` | 3Ch (60) FISCAL RECEIPT CANCELLATION (TERMINATION)
  `FiscalResponse` | `command61Variant0Version0​(java.lang.String date, java.lang.String time)` | 3Dh (61) SETTING THE DATE AND TIME
  `FiscalResponse` | `command61Variant1Version0​(java.lang.String dateTime)` | 3Dh (61) SETTING THE DATE AND TIME
  `FiscalResponse` | `command62Variant0Version0()` | 3Eh (62) READING THE DATE AND TIME
  `FiscalResponse` | `command63Variant0Version0()` | 3Fh (63) DISPLAY OF DATE AND TIME
  `FiscalResponse` | `command64Variant0Version0​(java.lang.String Option)` | 40h (64) INFORMATION ON THE LAST FISCAL RECORD
  `FiscalResponse` | `command65Variant0Version0​(java.lang.String option)` | 41h (65) INFORMATION ABOUT THE AMOUNTS BY TAX GROUPS FOR THE DAY
  `FiscalResponse` | `command65Variant1Version0()` | 41h (65) INFORMATION ABOUT THE AMOUNTS BY TAX GROUPS FOR THE DAY - Daily counters and amounts (1/3 part).
  `FiscalResponse` | `command65Variant2Version0()` | 41h (65) INFORMATION ABOUT THE AMOUNTS BY TAX GROUPS FOR THE DAY Daily counters and amounts (2/3 part).
  `FiscalResponse` | `command65Variant3Version0()` | 41h (65) INFORMATION ABOUT THE AMOUNTS BY TAX GROUPS FOR THE DAY Daily counters and amounts (3/3 part).
  `FiscalResponse` | `command65Variant5Version0()` | 41h (65) INFORMATION ABOUT THE AMOUNTS BY TAX GROUPS FOR THE DAY Reversal (storno) of turnover by tax groups.
  `FiscalResponse` | `command65Variant6Version0()` | 41h (65) INFORMATION ABOUT THE AMOUNTS BY TAX GROUPS FOR THE DAY Reversal (storno) of VAT by tax groups.
  `FiscalResponse` | `command65Variant7Version0()` | 41h (65) INFORMATION ABOUT THE AMOUNTS BY TAX GROUPS FOR THE DAY - Amounts of payments STORNO
  `FiscalResponse` | `command66Variant0Version0​(java.lang.String start, java.lang.String end)` | 42h (66) SET / READ INVOICE NUMBER RANGE
  `FiscalResponse` | `command68Variant0Version0()` | 44h (68) NUMBER OF AVAILABLE FIELDS IN FM
  `FiscalResponse` | `command69Variant0Version0​(java.lang.String reportType)` | 45h (69) DAILY FINANCIAL REPORT Clearing of the accumulated data by operators.
  `FiscalResponse` | `command70Variant0Version0​(java.lang.String amount)` | 6h (70) CASH-IN CASH-OUT - IMPORT AND EXPORT OF MONEY
  `FiscalResponse` | `command71Variant0Version0()` | 47h (71) PRINT OF DIAGNOSTIC INFORMATION
  `FiscalResponse` | `command73Variant0Version0​(java.lang.String SHA1, java.lang.String SkipZ, java.lang.String Start, java.lang.String End)` | 49h (73) FM REPORT BY BLOCK NUMBER
  `FiscalResponse` | `command74Variant0Version0​(java.lang.String option)` | 4Ah (74) GETTING STATUS
  `FiscalResponse` | `command74Variant1Version0()` | 4Ah (74) GETTING STATUS Returns the number of remaining lines to print.
  `FiscalResponse` | `command74Variant2Version0()` | 4Ah (74) GETTING STATUS Returns hardware information about the printer.
  `FiscalResponse` | `command74Variant3Version0()` | 4Ah (74) GETTING STATUS Returns data about the client documents sent to the NRA server.
  `FiscalResponse` | `command75Variant0Version0​(java.lang.String Restore)` | * 4Bh (75) FORCE PRESSURE PRINT
  `FiscalResponse` | `command76Variant0Version0​(java.lang.String option)` | 4Ch (76) FISCAL TRANSACTION STATUS
  `FiscalResponse` | `command79Variant0Version0​(java.lang.String start, java.lang.String end)` | 4Fh (79) FISCAL MEMORY REPORT FROM DATE TO DATE
  `FiscalResponse` | `command80Variant0Version0​(java.lang.String hz, java.lang.String mSec)` | 50H (80) SOUND SIGNAL
  `FiscalResponse` | `command83Variant0Version0​(java.lang.String multiplier, java.lang.String decimals, java.lang.String currency, java.lang.String enabledT, java.lang.String taxA, java.lang.String taxB, java.lang.String taxC, java.lang.String taxD, java.lang.String taxE, java.lang.String taxF, java.lang.String taxG, java.lang.String taxH)` | 53h (83) ESTABLISHMENT OF DECIMATES, CURRENCY AND TAX RATES
  `FiscalResponse` | `command83Variant1Version0()` | 53h (83) READING OF DECIMALS, CURRENCY AND TAX RATES
  `FiscalResponse` | `command84Variant0Version0​(java.lang.String bcType, java.lang.String bcData, java.lang.String sPrintBCdata)` | 54H (84) BARCODE PRINT - no text containing the barcode is printed.
  `FiscalResponse` | `command85Variant0Version0​(java.lang.String option, java.lang.String name)` | 55H (85) PROGRAMMING NAMES OF PAYMENTS
  `FiscalResponse` | `command85Variant1Version0​(java.lang.String option)` | 55H (85) READING THE NAMES OF PAYMENTS
  `FiscalResponse` | `command86Variant0Version0()` | 56H (86) READING THE DATE OF THE LATEST RECORD IN FISCAL MEMORY
  `FiscalResponse` | `command86Variant1Version0​(java.lang.String Option, java.lang.String Number)` | 56H (86) READING THE DATE OF THE LATEST RECORD IN FISCAL MEMORY
  `FiscalResponse` | `command87Variant0Version0​(java.lang.String dept, java.lang.String taxGr, java.lang.String line1, java.lang.String line2)` | 57H (87) DEPARTMENT NAME PROGRAMMING
  `FiscalResponse` | `command88Variant0Version0​(java.lang.String dept)` | 58H (88) RECEIPT OF DATA ON ACCUMULATED AMOUNTS FOR DEPARTMENT
  `FiscalResponse` | `command89Variant0Version0​(java.lang.String testType)` | 59h (89) PROGRAMMING OF THE PRODUCTION TEST AREA
  `FiscalResponse` | `command90Variant0Version0​(java.lang.String option)` | 5Ah (90) READING DIAGNOSTIC INFORMATION
  `FiscalResponse` | `command92Variant0Version0​(java.lang.String type)` | 5Ch (92) PRINT SEPARATION LINE
  `FiscalResponse` | `command92Variant1Version0​(java.lang.String type)` | 5Ch (92) PRINT SEPARATION LINE
  `FiscalResponse` | `command93Variant1Version0()` | 5Dh (93) RECEIPT OF INFORMATION ABOUT DISCOUNTS AND SURCHARGER FOR THE DAY
  `FiscalResponse` | `command94Variant0Version0​(java.lang.String SHA1, java.lang.String SkipZ, java.lang.String startDate, java.lang.String endDate)` | 5Eh (94) FULL FM REPORT BY DATE
  `FiscalResponse` | `command94Variant1Version0​(java.lang.String SHA1, java.lang.String SkipZ, java.lang.String startDate)` | 5Eh (94) FULL FM REPORT BY DATE MONTHLY OR ANNUALLY
  `FiscalResponse` | `command95Variant0Version0​(java.lang.String first, java.lang.String last)` | 5Fh (95) SHORT REPORT OF FM BY BLOCKS
  `FiscalResponse` | `command97Variant0Version0()` | 61h (97) READING OF ESTABLISHED TAX RATES
  `FiscalResponse` | `command98Variant0Version0​(java.lang.String text, java.lang.String name)` | 62h (98) ESTABLISHMENT OF THE EIK (UIC)
  `FiscalResponse` | `command99Variant0Version0()` | 63h (99) READING OF THE EIK (UIC)
  `boolean` | `getCapAutoCutter()` |
  `boolean` | `getCapFontSupported()` |
  `int` | `getLogoROW_NUM()` |
  `java.lang.Integer` | `getMAX_DEPARTMENT()` |
  `java.lang.Integer` | `getMAX_PLU()` |
  `int` | `getMaxBarcodeHeight_mm()` |
  `int` | `getMaxDepartments()` |
  `int` | `getMaxLinesToFeed()` |
  `int` | `getMaxLogoHeightPixel()` |
  `int` | `getMaxLogoWidthPixel()` |
  `java.lang.Integer` | `getMaxStockGroup()` |
  `int` | `getMinBarcodeHeight_mm()` |
  `int` | `getPrintColumns()` |

  ### Methods inherited from class com.datecs.fiscalprinter.SDK.FiscalDeviceV1

  `close, customCommand, getDefaultOpCode, getDefaultOpPass, getDefaultTillNumber, getInfo, getIsStatusCritical, getLastStatus, getMAX_PRICE, getMaxDisplayText, getMaxFiscalText, getMaxFooterLines, getMaxHeaderLines, getMaxNonFiscalText, getMaxOperators, getMaxTextHeaderFooter, getStatusBitBol, getStatusBitDescription, isCapAutoCutter, isChkInputParams, notDbl, notInt, queryStatus, setChkInputParams, setCriticalStatuses, setDebugLevel, setMsgSeparator, toDouble, toInt`

  ### Methods inherited from class java.lang.Object

  `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### WP50_BGR

    public WP50_BGR​(java.io.InputStream in, java.io.OutputStream out) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Parameters:
      `in` -
      `out` -
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### WP50_BGR

    public WP50_BGR​(AbstractTransportProtocol protocol) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Parameters:
      `protocol` -
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

- ## Method Details

  - ### command33Variant0Version0

    public FiscalResponse command33Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    21H (33) CLEARING THE DISPLAY
    Specified by:
      `command33Variant0Version0` in class `FiscalDeviceV1`
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command35Variant0Version0

    public FiscalResponse command35Variant0Version0​(java.lang.String text) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    23H (35) DISPLAY OF TEXT IN THE BOTTOM ROW OF THE DISPLAY
    Specified by:
      `command35Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `text` - Text up to 20 characters that is sent directly to display. It is preceded by a command for and clear the bottom row.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command38Variant0Version0

    public FiscalResponse command38Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    26H (38) OPENING OF NON FISCAL RECEIPT
    Specified by:
      `command38Variant0Version0` in class `FiscalDeviceV1`
    Returns:
      _ Allreceipt The number of all issued receipt (fiscal and non fiscal) from the last end of the day until now / 4 bytes /.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command39Variant0Version0

    public FiscalResponse command39Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    27h (39) CLOSURE OF NON FISCAL RECEIPT
    Specified by:
      `command39Variant0Version0` in class `FiscalDeviceV1`
    Returns:
      - Allreceipt - The number of all issued receipt (fiscal and non fiscal) from the last end of the day to moment / 4 bytes /.

      Fiscal device performs the following actions: â€¢ FOOTER is printed. â€¢ The serial number, date and time of the document are printed â€¢ "NON FISCAL RECEIPT" is printed.

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command42Variant0Version0

    public FiscalResponse command42Variant0Version0​(java.lang.String text) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    2Ah (42) FREE TEXT PRINTING IN OFFICE RECEIPT
    Specified by:
      `command42Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `text` - Text up to 40 characters.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command42Variant1Version0

    public FiscalResponse command42Variant1Version0​(java.lang.String Height, java.lang.String Text) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    2Ah (42) FREE TEXT PRINTING IN OFFICE RECEIPT
    Specified by:
      `command42Variant1Version0` in class `FiscalDeviceV1`
    Parameters:
      `Height` - '1' - Normal height print. '2' - 2x height printing. '3' - Print with 3x height.
      `Text` - Text up to 40 characters.
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command43Variant0Version0

    public FiscalResponse command43Variant0Version0​(java.lang.String itemIndex, java.lang.String itemText) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    2Bh (43) WRITE HEADER AND FOOTER

    HEADER consists of 6 lines of text that are printed at the beginning of each fiscal or service receipt. For normal operation of the FD it is necessary to set at least 2 rows of Header. EIK (set by command 98) is always printed on the third line, so the lines from the HEADER after the second is automatically moved one position down. FOOTER consists of 2 lines of text that are printed at the end of each receipt. HEADER and FOOTER are centered automatically. This command must be executed up to 8 times to set all HEADER and FOOTER lines.

    Specified by:
      `command43Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `itemIndex` - '0' to '7' is the line number to be set. HEADER lines are numbered from 0 to 5, and those of FOOTER - 6 and 7.
      `itemText` - The text of the line.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command43Variant1Version0

    public FiscalResponse command43Variant1Version0​(java.lang.String printOption, java.lang.String value) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    2Bh (43) PRINT OPTIONS
    Specified by:
      `command43Variant1Version0` in class `FiscalDeviceV1`
    Parameters:
      `printOption` - 'A' Automatically format sales as invoice (4 separate lines). 'B' Sets the height of the barcode in pixels (0.125 mm). Possible values â€‹â€‹from 24 (3 mm) to 240 (30 mm). The barcode is printed with command 84 (54H). 'C' Enable / disable automatic paper cut after each document. After turning on the printer, the behavior of the printer is determined by Sw8 key.

      'D' Sets the print density. Possible values: '1': Very pale '2': Pale '3': Normal '4': Solid '5': Very dense

      'E' Enable / disable the printing of the total amount in EUR for the first command for payment (53) in a fiscal receipt. Printing is disabled by default. Optionally the command sets the valid EUR / BGN rate. Data syntax: Enable [, Rate] Enable Flag to disable / enable printing. One byte: '0' or '1'. Rate Exchange rate. Floating number with up to 8 significant digits and 5 decimal places. If missing, the old value is retained. If v0.00000, the value in Euro is not printed regardless of Enable.

      'L' Enable / disable the printing of the graphic logo immediately before HEADER. The logo is defined with command 115. The Text data is in the format Enable, H. H is the height of the logo in pixels, and Enable is one byte with value '1' (enabled) or '0' (disabled).

      'N' Enable / disable the printing of the department name in the beginning of each fiscal receipt.

      'T' Enable / disable the printing of the accrued VAT for the receipt in normal (not extended) fiscal receipt.

      'X' Enable / disable automatic pulse generation for open drawer with commands 53 (35H) and 70 (46H).

      `value` -
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command43Variant2Version0

    public FiscalResponse command43Variant2Version0​(java.lang.String itemOption) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    2Bh (43) PRINTING - READING OPTIONS
    Specified by:
      `command43Variant2Version0` in class `FiscalDeviceV1`
    Parameters:
      `itemOption` - 'I' Allows us to read the values previously set with command 43. The letter 'I' is followed by exactly one more character that matches one of the command43Variant1Version0
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command43Variant2Version1

    public FiscalResponse command43Variant2Version1​(java.lang.String lineNumber) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    2Bh (43) PRINTING - READING OPTIONS Reading clichÃ©s
    Specified by:
      `command43Variant2Version1` in class `FiscalDeviceV1`
    Parameters:
      `lineNumber` - - '0' to '7' is the number of the line being read. HEADER lines are numbered 0 to 5, and FOOTER lines are 6 and 7.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command44Variant0Version0

    public FiscalResponse command44Variant0Version0​(java.lang.String lines) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    2Ch (44) FEED THE PAPER
    Specified by:
      `command44Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `lines` - The number of lines to feed the paper. Must be a positive number not greater than 99. If a parameter is missing, 1 line is assumed.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command46Variant0Version0

    public FiscalResponse command46Variant0Version0​(java.lang.String OpCode, java.lang.String OpPwd, java.lang.String NSale, java.lang.String TillNmb, java.lang.String DocType, java.lang.String DocNumber, java.lang.String DocDateTime, java.lang.String FMNumber, java.lang.String Invoice, java.lang.String InvNumber, java.lang.String Reason) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    2E (46) ISSUE OF A REFUND RECEIPT (STORNO)
    Specified by:
      `command46Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `OpCode` - - Operator number (number 1 - 30).
      `OpPwd` - - Operator password (up to 8 characters).
      `NSale` - - Unique sale number (21 characters CCCCCCCC-CCCC-DDDDDDD format [0-9A-Za-z] {8} - [0-9A-Za-z] {4} - [0-9] {7})
      `TillNmb` - - Cashier place number (number 1 - 99999).
      `DocType` - - Reason for reversing the document (number 0 - 1). 0 - operator error. 1 - return / exchange. 2 - reduction of the tax base.
      `DocNumber` - - Number of the document on which the reversal is (number 1 - 9999999).
      `DocDateTime` - - Date and time of the document in which the reversal format is (DDMMYYYY or DDMMYYYYYYY). Example: 30 March 2018 16:13 - "3003181613" or "300318161300".
      `FMNumber` - - Fiscal memory number from the document on which the reversal is (number written with 8 characters).

      Optional parameters:

      `Invoice` - - Revoked on invoice one symbol with value - 'I'.
      `InvNumber` - - Invoice number on which the reversal is (number 1 - 9999999999).
      `Reason` - - Reason for issue. Up to 42 characters.
    Returns:
      - Result - One byte

      Allreceipt - The number of all issued receipt (fiscal and service) since the last one end of the day so far. / 4 bytes /. StornoReceipt - The number of all issued fiscal CANCEL receipt since the last one end of the day so far. / 4 bytes /.

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command47Variant0Version0

    public FiscalResponse command47Variant0Version0​(java.lang.String text) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    2Fh (47) DISPLAY OF TEXT ON THE TOP OF THE DISPLAY
    Specified by:
      `command47Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `text` - Text up to 20 characters that is sent directly to the display. Before it is sent a command to position and clear the top row. The command is rejected if a fiscal receipt is opened.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### getMaxLinesToFeed

    public int getMaxLinesToFeed()
    Specified by:
      `getMaxLinesToFeed` in class `FiscalDeviceV1`

  - ### command48Variant0Version0

    public FiscalResponse command48Variant0Version0​(java.lang.String OpNum, java.lang.String Password, java.lang.String TillNum, java.lang.String NSale) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    30h (48) OPENING OF A FISCAL (CUSTOMER) RECEIPT
    Specified by:
      `command48Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `OpNum` - Operator number / 1 to 16 /
      `Password` - Operator password / 1 to 8 digits /
      `TillNum` - Cashier number / integer from 1 to 99999 /
      `NSale` - Unique sales UNP number (21 characters CCCCCCCC-CCCC-DDDDDDD format [0-9A-Za-z] {8} - [0-9A-Za-z] {4} - [0-9] {7})
    Returns:
      - Allreceipt - The number of all issued receipt (fiscal and non fical) from the last end of the day to.

      FiscReceipt - The number of all fiscal receipt issued by closing the day so far.

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command48Variant1Version0

    public FiscalResponse command48Variant1Version0​(java.lang.String OpCode, java.lang.String OpPwd, java.lang.String TillNmb, java.lang.String NSale) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    30h (48) OPENING OF A FISCAL (CUSTOMER) RECEIPT -extended customer invoice
    Specified by:
      `command48Variant1Version0` in class `FiscalDeviceV1`
    Parameters:
      `OpCode` - Operator number / 1 to 30 /
      `OpPwd` - Operator password / 1 to 8 digits /
      `TillNmb` - Cashier number / integer from 1 to 99999 /
      `NSale` - Unique sales UNP number (21 characters CCCCCCCC-CCCC-DDDDDDD format [0-9A-Za-z] {8} - [0-9A-Za-z] {4} - [0-9] {7})
    Returns:
      _ Allreceipt The number of all issued receipt (fiscal and official) from the last end of the day to. FiscReceipt The number of all fiscal receipt issued by end of the day so far.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command48Variant2Version0

    public FiscalResponse command48Variant2Version0() throws java.io.IOException, FiscalException
    30h (48) Serial number of the sale by the LPG of the last issued fiscal / cancellation receipt. -extended customer note (invoice)
    Specified by:
      `command48Variant2Version0` in class `FiscalDeviceV1`
    Returns:
      - UNP - Unique sales number (format: serial number of FD "-" four digits or Latin letters "-" number of the sale (seven digits with leading zeros) "example: 0001000)
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command49Variant0Version0

    public FiscalResponse command49Variant0Version0​(java.lang.String L1, java.lang.String L2, java.lang.String taxCd, java.lang.String price, java.lang.String quan, java.lang.String perc) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    31h (49) REGISTRATION (SALE) OF ITEM

    Percentage surcharge / discount

    Specified by:
      `command49Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `L1` - Text up to 22 bytes containing a line describing the sale
      `L2` - Text up to 22 bytes containing a second line describing the sale
      `taxCd` - One byte containing the letter indicating the type of tax ('A', 'B', 'C', ...). There is a restriction depending on the Enabled_taxes parameter, which is set at setting the currency in command 83.
      `price` - Price up to 8 significant digits.
      `quan` - The quantity of the item. The default is 1,000. Length up to 8 significant digits (not more than 3 after the decimal point). The product Price * Qwan is rounded from FDto the specified number of decimal places and also should not exceed 8 significant digits.
      `perc` - Parameter showing the value of the surcharge or discount (depending on characters) as a percentage of current sales. Permissible values â€‹â€‹are from -99.00% to 99.00%. Up to 2 decimal places are accepted. (Correction on 09/29/2019 -100%, 100%)
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command49Variant1Version0

    public FiscalResponse command49Variant1Version0​(java.lang.String L1, java.lang.String L2, java.lang.String taxCd, java.lang.String price, java.lang.String quan, java.lang.String absSum) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    31h (49) REGISTRATION (SALE) OF ITEM surcharge / discount by value
    Specified by:
      `command49Variant1Version0` in class `FiscalDeviceV1`
    Parameters:
      `L1` - Text up to 22 bytes containing a line describing the sale
      `L2` - Text up to 22 bytes containing a second line describing the sale
      `taxCd` - One byte containing the letter indicating the type of tax ('A', 'B', 'C', ...). There is a restriction depending on the Enabled_taxes parameter, which is set at setting the currency in command 83.
      `price` - Price up to 8 significant digits.
      `quan` - The quantity of the item. The default is 1,000. Length up to 8 significant digits (not more than 3 after the decimal point). The product Price * Qwan is rounded off by FU up to the specified number of decimal places and also must not exceed 8 significant digits.
      `absSum` - Parameter showing the value of the surcharge or discount (depending on characters) as a sum. No discount with a value greater than the value of the sale is allowed.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command49Variant0Version1

    public FiscalResponse command49Variant0Version1​(java.lang.String L1, java.lang.String L2, java.lang.String Dept, java.lang.String price, java.lang.String quan, java.lang.String perc) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    31h (49) REGISTRATION (SALE) OF ITEM Percentage surcharge / discount
    Specified by:
      `command49Variant0Version1` in class `FiscalDeviceV1`
    Parameters:
      `L1` - Text up to 22 bytes containing a line describing the sale
      `L2` - Text up to 22 bytes containing a second line describing the sale
      `Dept` - Department number. Integer from 1 to 60 inclusive. The sale is belongs to the tax group with which the department is associated at its programming.
      `price` - Price up to 8 significant digits.
      `quan` - The quantity of the item. The default is 1,000. Length up to 8 significant digits (not more than 3 after the decimal point). The product Price * Qwan is rounded from FDto the specified number of decimal places and also should not exceed 8 significant digits.
      `perc` - Parameter showing the value of the surcharge or discount (depending on characters) as a percentage of current sales. Permissible values â€‹â€‹are from -99.00% to 99.00%. Up to 2 decimal places are accepted. (Correction on 09/29/2019 -100%, 100%)
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command49Variant1Version1

    public FiscalResponse command49Variant1Version1​(java.lang.String L1, java.lang.String L2, java.lang.String Dept, java.lang.String price, java.lang.String quan, java.lang.String absSum) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    31h (49) REGISTRATION (SALE) OF ITEM surcharge / discount by value
    Specified by:
      `command49Variant1Version1` in class `FiscalDeviceV1`
    Parameters:
      `L1` - Text up to 22 bytes containing a line describing the sale
      `L2` - Text up to 22 bytes containing a second line describing the sale
      `Dept` - A byte containing the letter indicating the type of tax ('A', 'B', 'C', ...). There is a restriction depending on the Enabled_taxes parameter, which is set at setting the currency in command 83.
      `price` - Price up to 8 significant digits.
      `quan` - The quantity of the item. The default is 1,000. Length up to 8 significant digits (not more than 3 after the decimal point). The product Price * Qwan is rounded off by FU up to the specified number of decimal places and also must not exceed 8 significant digits.
      `absSum` - Parameter showing the value of the surcharge or discount (depending on characters) as a sum. No discount with a value greater than the value of the sale is allowed.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command50Variant0Version0

    public FiscalResponse command50Variant0Version0​(java.lang.String startDate, java.lang.String endDate) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    32h (50) TAX RATES DURING THE RELEVANT PERIOD Returns the values that were set during the time period
    Specified by:
      `command50Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `startDate` - Period start date - DDMMYY
      `endDate` - Period end date - DDMMYY
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command51Variant0Version0

    public FiscalResponse command51Variant0Version0​(java.lang.String print, java.lang.String display) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    33h (51) SUBTOTAL
    Specified by:
      `command51Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `print` - One byte, which if '1' is the value of the subtotal will be printed.
      `display` - One byte, which if '1' is the value of the subtotal will be shown on the display.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command51Variant1Version0

    public FiscalResponse command51Variant1Version0​(java.lang.String print, java.lang.String display, java.lang.String perc) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    33h (51) SUBTOTAL With a percentage discount / surcharge
    Specified by:
      `command51Variant1Version0` in class `FiscalDeviceV1`
    Parameters:
      `print` - One byte, which if '1' is the value of the subtotal will be printed.
      `display` - One byte, which if '1' is the value of the subtotal will be shown on the display.
      `perc` - The value as a percentage of the discount or surcharge on the amount accumulated so far.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command51Variant2Version0

    public FiscalResponse command51Variant2Version0​(java.lang.String print, java.lang.String display, java.lang.String absSum) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    33h (51) SUBTOTAL Discount / surcharge in absolute value
    Specified by:
      `command51Variant2Version0` in class `FiscalDeviceV1`
    Parameters:
      `print` - One byte, which if '1' is the value of the subtotal will be printed.
      `display` - One byte, which if '1' is the value of the subtotal will be shown on the display.
      `absSum` - The value of the surcharge or discount (depending on the sign) as an amount (up to 8 significant digits). No discount with a value greater than the value of the sale is allowed.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command52Variant0Version0

    public FiscalResponse command52Variant0Version0​(java.lang.String L1, java.lang.String taxCd, java.lang.String price, java.lang.String quan, java.lang.String UN, java.lang.String perc) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    34h (52) REGISTRATION AND DISPLAY Percentage increase / discount
    Specified by:
      `command52Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `L1` - Text up to 22 bytes containing a line describing the sale
      `taxCd` - One byte containing the letter indicating the type of tax ('A', 'B', 'C', ...). There is a restriction depending on the Enabled_taxes parameter, which is set at setting the currency in command 83.
      `price` - Price up to 8 significant digits.
      `quan` - The quantity of the item. The default is 1,000. Length up to 8 significant digits (not more than 3 after the decimal point). The product Price * Qwan is rounded from FDto the specified number of decimal places and also should not exceed 8 significant digits.
      `UN` - Unit name. Optional text for unit of quantity up to 8 symbols, for example "kg".
      `perc` - Parameter showing the value of the surcharge or discount (depending on sign) as a percentage of current sales. Permissible values â€‹â€‹are from -99.00% to 99.00%. Up to 2 decimal places are accepted. (Correction on 09/29/2019 -100%, 100%)
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command52Variant1Version0

    public FiscalResponse command52Variant1Version0​(java.lang.String L1, java.lang.String taxCd, java.lang.String price, java.lang.String quan, java.lang.String absSum) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    34h (52) REGISTRATION AND DISPLAY surcharge / discount on value
    Specified by:
      `command52Variant1Version0` in class `FiscalDeviceV1`
    Parameters:
      `L1` - Text up to 22 bytes containing a line describing the sale
      `taxCd` - One byte containing the letter indicating the type of tax ('A', 'B', 'C', ...). There is a restriction depending on the Enabled_taxes parameter, which is set at setting the currency in command 83.
      `price` - Price up to 8 significant digits.
      `quan` - The quantity of the item. The default is 1,000. Length up to 8 significant digits (not more than 3 after the decimal point). The product Price * Qwan is rounded off by FU up to the specified number of decimal places and also must not exceed 8 significant digits.
      `absSum` - Parameter showing the value of the surcharge or discount (depending on sign) as a sum. No discount with a value greater than the value of the sale is allowed.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command52Variant0Version1

    public FiscalResponse command52Variant0Version1​(java.lang.String L1, java.lang.String Dept, java.lang.String price, java.lang.String quan, java.lang.String perc) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    34h (52) REGISTRATION AND DISPLAY Percentage surcharge / discount
    Specified by:
      `command52Variant0Version1` in class `FiscalDeviceV1`
    Parameters:
      `L1` - Text up to 22 bytes containing a line describing the sale
      `Dept` - Department number. Integer from 1 to 60 inclusive. The sale is belongs to the tax group with which the department is associated at its programming.
      `price` - Price up to 8 significant digits.
      `quan` - The quantity of the item. The default is 1,000. Length up to 8 significant digits (not more than 3 after the decimal point). The product Price * Qwan is rounded from FDto the specified number of decimal places and also should not exceed 8 significant digits.
      `perc` - Parameter showing the value of the surcharge or discount (depending on sign) as a percentage of current sales. Permissible values â€‹â€‹are from -99.00% to 99.00%. Up to 2 decimal places are accepted. (Correction on 09/29/2019 -100%, 100%)
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command52Variant1Version1

    public FiscalResponse command52Variant1Version1​(java.lang.String L1, java.lang.String Dept, java.lang.String price, java.lang.String quan, java.lang.String absSum) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    34h (52) REGISTRATION AND DISPLAY surcharge / discount by value
    Specified by:
      `command52Variant1Version1` in class `FiscalDeviceV1`
    Parameters:
      `L1` - Text up to 22 bytes containing a line describing the sale
      `Dept` - A byte containing the letter indicating the type of tax ('A', 'B', 'C', ...). There is a restriction depending on the Enabled_taxes parameter, which is set at setting the currency in command 83.
      `price` - Price up to 8 significant digits.
      `quan` - The quantity of the goods. The default is 1,000. Length up to 8 significant digits (not more than 3 after the decimal point). The product Price * Qwan is rounded off by FU up to the specified number of decimal places and also must not exceed 8 significant digits.
      `absSum` - Parameter showing the value of the surcharge or discount (depending on sign) as a sum. No discount with a value greater than the value of the sale is allowed.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command53Variant0Version0

    public FiscalResponse command53Variant0Version0​(java.lang.String L1, java.lang.String L2, java.lang.String paidMode, java.lang.String amount) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    35h (53) CALCULATION OF TOTAL
    Specified by:
      `command53Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `L1` - Text up to 36 bytes containing the first line
      `L2` - Text up to 36 bytes containing the second line
      `paidMode` - 'P' - Cash payment (default); 'N' - Payment by credit; 'C' - Payment by check; 'D' - Debit card payment 'I' - Programmable payment type 1 'J' - Programmable payment type 2 'K' - Programmable payment type 3 'L' - Programmable payment type 4 'I' - Programmable payment type 1 'J' - Programmable payment type 2 'K' - Programmable payment type 3 'L' - Programmable payment type 4 'M' - Coupons 'N' - External coupons 'O' - Packaging 'P' - Internal service 'Q' - Damage 'R' - Bank transfers 'S' - With check
      `amount` - The amount to be paid / up to 10 significant digits /.
    Returns:
      - Amount - Up to 9 digits with a sign. Depends on PaidCode. PaidCode - One byte - result of command execution. 'F' Error. 'E' Calculated under an amount is negative. No payment will be made and Amount will contain the negative amount below. 'D' If the amount paid is less than the amount of the receipt. The balance of the surcharge is returned to Amount. 'R' If the amount paid is greater than the sum of the note. A "RESTO" message will be printed and the rest will be returned to Amount. 'I' The amount in any tax group was negative and therefore an error occurred. Amount returns the current sub amount.

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command54Variant0Version0

    public FiscalResponse command54Variant0Version0​(java.lang.String text) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    36h (54) PRINTING FISCAL FREE TEXT
    Specified by:
      `command54Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `text` - Text up to 36 characters.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command56Variant0Version0

    public FiscalResponse command56Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    38h (56) CLOSING (CLOSING) OF A FISCAL RECEIPT
    Specified by:
      `command56Variant0Version0` in class `FiscalDeviceV1`
    Returns:
      - Allreceipt - All receipts issued since the last end of the day so far. FiscReceipt - All issued fiscal receipts from the last end of the day so far.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command57Variant0Version0

    public FiscalResponse command57Variant0Version0​(java.lang.String Bulstat, java.lang.String seller, java.lang.String receiver, java.lang.String client, java.lang.String taxNo, java.lang.String address) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    39h (57) PRINT OF CUSTOMER INFORMATION
    Specified by:
      `command57Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `Bulstat` - EIK number of the buyer. Between 9 and 14 characters.
      `seller` - Tab (09H). Separator between parameters.
      `receiver` - Name of the seller. Up to 36 characters.
      `client` - Recipient's name. Up to 36 characters.
      `taxNo` - VAT number of the buyer. Between 10 and 14 characters.
      `address` - Address of the buyer. Up to two lines of text of a maximum of 36 characters, separated by LF (0AH).
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command57Variant1Version0

    public FiscalResponse command57Variant1Version0​(java.lang.String typeEIK, java.lang.String EIK, java.lang.String seller, java.lang.String receiver, java.lang.String client, java.lang.String taxNo, java.lang.String address) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    39h (57) PRINT OF CUSTOMER INFORMATION
    Specified by:
      `command57Variant1Version0` in class `FiscalDeviceV1`
    Parameters:
      `typeEIK` - 0 - Bulstat EIK. 1 - EGN. Unique citizenship number 2 - LNC. Personal number of a foreigner 3 - Fig. number.
      `EIK` - Number. Between 9 and 14 characters.
      `seller` - Tab (09H). Separator between parameters.
      `receiver` - Name of the seller. Up to 36 characters.
      `client` - Recipient's name. Up to 36 characters.
      `taxNo` - VAT number of the buyer. Between 10 and 14 characters.
      `address` - Address of the buyer. Up to two lines of text of a maximum of 36 characters, separated by LF (0AH).
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command58Variant0Version0

    public FiscalResponse command58Variant0Version0​(java.lang.String display, java.lang.String plu, java.lang.String dept, java.lang.String quan, java.lang.String perc) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    3Ah (58) REGISTRATION (SALE) OF PROGRAMMED ITEM (PLU) Percentage surcharge or discount
    Specified by:
      `command58Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `display` - - If the string is empty, the sale is not shown on the customer display. If the length of the item name is more than 20, the characters after the 20th are cut off.
      `plu` - This is the item number. Integer from 1 to 999999999 (up to 9 digits).
      `dept` - Department number. Integer from 1 to 60 inclusive. If this parameter is present, then the separating tabs must be present.
      `quan` - Parameter specifying the quantity of the item. The default is 1,000. Length up to 8 significant digits (not more than 3 after the decimal point). The product (Unit price) * Qwan is rounded from FD to the specified number of decimal places and also should not exceed 8 significant digits.
      `perc` - Parameter indicating the value of the surcharge or discount (depending on the sign) in percentages on the current sale. Permissible values â€‹â€‹are from -99.00% to 99.00%. Up to 2 decimal places are accepted. (Correction on 09/29/2019 -100%, 100%)
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command58Variant0Version1

    public FiscalResponse command58Variant0Version1​(java.lang.String D, java.lang.String plu, java.lang.String dept, java.lang.String quan, java.lang.String abs) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    3Ah (58) REGISTRATION (SALE) OF PROGRAMMED ITEM (PLU) surcharge or discount by value
    Specified by:
      `command58Variant0Version1` in class `FiscalDeviceV1`
    Parameters:
      `D` -
      `plu` - This is the item number. Integer from 1 to 999999999 (up to 9 digits).
      `dept` - Department number. Integer from 1 to 60 inclusive. If this parameter is present, then the separating tabs must be present.
      `quan` - Parameter specifying the quantity of the item. The default is 1,000. Length up to 8 significant digits (not more than 3 after the decimal point). The product (Unit price) * Qwan is rounded from FD to the specified number of decimal places and also should not exceed 8 significant digits.
      `abs` - Parameter indicating the value of the surcharge or discount (depending on the sign) as an amount. No discount with a value greater than the value of the sale is allowed.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command60Variant0Version0

    public FiscalResponse command60Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    3Ch (60) FISCAL RECEIPT CANCELLATION (TERMINATION)
    Specified by:
      `command60Variant0Version0` in class `FiscalDeviceV1`
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command61Variant0Version0

    public FiscalResponse command61Variant0Version0​(java.lang.String date, java.lang.String time) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    3Dh (61) SETTING THE DATE AND TIME
    Specified by:
      `command61Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `date` - DD-MM-YY
      `time` - HH:MM[:SS]
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command61Variant1Version0

    public FiscalResponse command61Variant1Version0​(java.lang.String dateTime) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    3Dh (61) SETTING THE DATE AND TIME
    Specified by:
      `command61Variant1Version0` in class `FiscalDeviceV1`
    Parameters:
      `dateTime` - DD-MM-YY HH:MM[:SS]
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command62Variant0Version0

    public FiscalResponse command62Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    3Eh (62) READING THE DATE AND TIME
    Specified by:
      `command62Variant0Version0` in class `FiscalDeviceV1`
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command63Variant0Version0

    public FiscalResponse command63Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    3Fh (63) DISPLAY OF DATE AND TIME
    Specified by:
      `command63Variant0Version0` in class `FiscalDeviceV1`
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command64Variant0Version0

    public FiscalResponse command64Variant0Version0​(java.lang.String Option) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    40h (64) INFORMATION ON THE LAST FISCAL RECORD
    Specified by:
      `command64Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `Option` - - No parameter - Amounts by sales tax groups. '0' - Amounts by sales tax groups. '1' - Amounts by tax groups from reversal transactions (storno).

    Returns:
      ErrCode Error code: 'P' The command is successful. Data follows. 'F' The last entry is not read. Closure This is the number of the last fiscal record - 4 bytes. TaxX Amount of turnover by tax group X, depending on the input parameter. 12 bytes with sign. ClosureDate The date of the fiscal record - 6 bytes / DDMMYY /.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command65Variant0Version0

    public FiscalResponse command65Variant0Version0​(java.lang.String option) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    41h (65) INFORMATION ABOUT THE AMOUNTS BY TAX GROUPS FOR THE DAY
    Specified by:
      `command65Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `option` - Specifies what information to return: '0' - Turnover by tax groups. '1' - VAT by tax groups. If the parameter is missing, the default is '0'
    Returns:
      TaxA, TaxB, TaxC, TaxD, TaxE, TaxF, TaxG, TaxH The amounts by tax groups (Total turnover) from the last end of the day to the moment of receive the command. Option = 1 TaxA, TaxB, TaxC, TaxD, TaxE, TaxF, TaxG, TaxH * The amounts by tax groups (Accumulated VAT) from the last end of the day until now are refunded * on receiving the command.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command65Variant1Version0

    public FiscalResponse command65Variant1Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    41h (65) INFORMATION ABOUT THE AMOUNTS BY TAX GROUPS FOR THE DAY - Daily counters and amounts (1/3 part).
    Specified by:
      `command65Variant1Version0` in class `FiscalDeviceV1`
    Returns:
      - qKLN Number of customers. sPROD Sales amount. sNDB Allowance amount. qNDB Number of allowances. sOTS Amount of discounts. qOTS Number of discounts. sVD Amount of void. qVD Number of void. sZSTR Amount canceled (canceled receipt). qZSTR Number of canceled receipt.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command65Variant2Version0

    public FiscalResponse command65Variant2Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    41h (65) INFORMATION ABOUT THE AMOUNTS BY TAX GROUPS FOR THE DAY Daily counters and amounts (2/3 part).
    Specified by:
      `command65Variant2Version0` in class `FiscalDeviceV1`
    Returns:
      - sPYForeign Amount paid in alternative currency. sPYLocal The amount of the payment in an alternative currency is equal to the base currency (at the current exchange rate). sVV Amount cash-in. qVV Number cash-in . sIZ Amount cash-out. qIZ Number of cash-out. sVValt Amount of cash-in in alternative currency. qVValt Number of cash-in in alternative currency. sIZalt Amount cash-out in alternate currency. qIZalt Number cash-out in alternate currency.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command65Variant3Version0

    public FiscalResponse command65Variant3Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    41h (65) INFORMATION ABOUT THE AMOUNTS BY TAX GROUPS FOR THE DAY Daily counters and amounts (3/3 part).
    Specified by:
      `command65Variant3Version0` in class `FiscalDeviceV1`
    Returns:
      - sPY0 Cash payment. sPY1 Payment 1. sPY2 Payment 2. sPY3 Payment 3. sPY4 Payment 4. sPY5 Payment 5.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command65Variant5Version0

    public FiscalResponse command65Variant5Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    41h (65) INFORMATION ABOUT THE AMOUNTS BY TAX GROUPS FOR THE DAY Reversal (storno) of turnover by tax groups.
    Specified by:
      `command65Variant5Version0` in class `FiscalDeviceV1`
    Returns:
      - StrX -Amount STORNO turnover by tax group X. 12 bytes with sign.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command65Variant6Version0

    public FiscalResponse command65Variant6Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    41h (65) INFORMATION ABOUT THE AMOUNTS BY TAX GROUPS FOR THE DAY Reversal (storno) of VAT by tax groups.
    Specified by:
      `command65Variant6Version0` in class `FiscalDeviceV1`
    Returns:
      - VatStrX Reversal (storno) of VAT by tax group X. 12 bytes with sign.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command65Variant7Version0

    public FiscalResponse command65Variant7Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    41h (65) INFORMATION ABOUT THE AMOUNTS BY TAX GROUPS FOR THE DAY - Amounts of payments STORNO
    Specified by:
      `command65Variant7Version0` in class `FiscalDeviceV1`
    Returns:
      - sPYXStr - Payment reverse X. 12 bytes with sign.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command66Variant0Version0

    public FiscalResponse command66Variant0Version0​(java.lang.String start, java.lang.String end) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    42h (66) SET / READ INVOICE NUMBER RANGE
    Specified by:
      `command66Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `start` -
      `end` -
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command68Variant0Version0

    public FiscalResponse command68Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    44h (68) NUMBER OF AVAILABLE FIELDS IN FM
    Specified by:
      `command68Variant0Version0` in class `FiscalDeviceV1`
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command69Variant0Version0

    public FiscalResponse command69Variant0Version0​(java.lang.String reportType) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    45h (69) DAILY FINANCIAL REPORT Clearing of the accumulated data by operators.
    Specified by:
      `command69Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `reportType` - '0' A Z-report is printed. The printout ends with the inscription "FISCAL RECEIPT". '2' A daily financial report is made without resetting (ie no entry is made in fiscal memory and register reset). The printout ends with a logo "NON FISCAL RECEIPT The presence of the symbol N at the end of the data prohibits the clearing of the accumulated ones data by operators in a report.
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command70Variant0Version0

    public FiscalResponse command70Variant0Version0​(java.lang.String amount) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    6h (70) CASH-IN CASH-OUT - IMPORT AND EXPORT OF MONEY
    Specified by:
      `command70Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `amount` - The registration amount (up to 10 significant digits). Depending on the sign of the number it is interpreted as import or export.
    Returns:
      - CashSum - Cash Apart from this command, the amount increases and for each cash payment. ServIn The sum of all "Cash-in" commands. ServOut The sum of all Cash-out commands.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command71Variant0Version0

    public FiscalResponse command71Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    47h (71) PRINT OF DIAGNOSTIC INFORMATION
    Specified by:
      `command71Variant0Version0` in class `FiscalDeviceV1`
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command73Variant0Version0

    public FiscalResponse command73Variant0Version0​(java.lang.String SHA1, java.lang.String SkipZ, java.lang.String Start, java.lang.String End) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    49h (73) FM REPORT BY BLOCK NUMBER
    Specified by:
      `command73Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `SHA1` - Optional argument - one byte with value '#'. If present, for each Z-report also prints the checksum according to SHA-1 algorithm.
      `SkipZ` - Optional argument - one byte with value '*'. If present, for each Z-report print only the tax rates for which the accumulated amounts for the day are non-zero. Such report is non-standard and can be used only for internal inquiries of the site!
      `Start` - Number of the initial fiscal block. 4 bytes.
      `End` - Number of the final fiscal block. 4 bytes.
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command74Variant0Version0

    public FiscalResponse command74Variant0Version0​(java.lang.String option) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    4Ah (74) GETTING STATUS
    Specified by:
      `command74Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `option` - One byte with the following meanings: W First, wait for everything to print from the printer's print buffer. X Does not wait for the printer, but answers immediately.

      P Returns hardware information for the printer. R Returns data about the client documents sent to the NRA server.

    Returns:
      Sn Status byte N.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command74Variant1Version0

    public FiscalResponse command74Variant1Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    4Ah (74) GETTING STATUS Returns the number of remaining lines to print.
    Specified by:
      `command74Variant1Version0` in class `FiscalDeviceV1`
    Returns:
      Nlines Number of unprinted lines in the print buffer. A value of 0 means that there is no data waiting to be printed.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command74Variant2Version0

    public FiscalResponse command74Variant2Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    4Ah (74) GETTING STATUS Returns hardware information about the printer.
    Specified by:
      `command74Variant2Version0` in class `FiscalDeviceV1`
    Returns:
      - HdwInfo - Returns statistics on the operation of the printer from its production to the present. The data are in the format: P Len, Docs, Cuts, PwOns, MdRst Len Length of printed paper in millimeters. Docs Number of printed documents. Cuts Number of paper cuts. PwOns Number of printer starts. MdRst Number of reboots of the modem. Not supported at this time.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command74Variant3Version0

    public FiscalResponse command74Variant3Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    4Ah (74) GETTING STATUS Returns data about the client documents sent to the NRA server. InfoReciepts Returns data on sent and unsent client receipt

    Specified by:
      `command74Variant3Version0` in class `FiscalDeviceV1`
    Returns:
      - Lastprintdoc - Number of the last printed document. Nlastsentdoc - Number of the last successfully sent document. Dtlastsentdoc -Date and time of the last successfully sent document. Minlastsuccesssent - Minutes from the last successfully sent document. Nfirstnotsentdoc - Number of the first document not sent. Dtfirstnotsentdoc - Date and time of the first unsent document. Minfirstnotsuccesssent - Minutes from the first unsent document.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command75Variant0Version0

    public FiscalResponse command75Variant0Version0​(java.lang.String Restore) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    * 4Bh (75) FORCE PRESSURE PRINT
    Specified by:
      `command75Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `Restore` - 0 After printing, it is enabled - the following data will be printed immediately. 1 After clearing the print buffer, it remains suppressed until the end of the receipt.
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command76Variant0Version0

    public FiscalResponse command76Variant0Version0​(java.lang.String option) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    4Ch (76) FISCAL TRANSACTION STATUS
    Specified by:
      `command76Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `option` - 'T'. If this parameter is specified, the command will return information about the current balance of the account due so far by the client
    Returns:
      - Open - A byte that is '1' if a fiscal or non fiscal receipt is open (what exactly can be understood by status bits), and '0' if there is no open receipt. Items - The number of sales registered on the current or last fiscal receipt. 4 bytes. Amount - The amount of the last fiscal receipt - 9 bytes with a sign. Tender - The amount paid on the next or last receipt. 9 bytes with sign.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command79Variant0Version0

    public FiscalResponse command79Variant0Version0​(java.lang.String start, java.lang.String end) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    4Fh (79) FISCAL MEMORY REPORT FROM DATE TO DATE
    Specified by:
      `command79Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `start` - Start date: 6 bytes (DDMMYY)
      `end` - End date: 6 bytes (DDMMYY)
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command80Variant0Version0

    public FiscalResponse command80Variant0Version0​(java.lang.String hz, java.lang.String mSec) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    50H (80) SOUND SIGNAL
    Specified by:
      `command80Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `hz` -
      `mSec` -
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command83Variant0Version0

    public FiscalResponse command83Variant0Version0​(java.lang.String multiplier, java.lang.String decimals, java.lang.String currency, java.lang.String enabledT, java.lang.String taxA, java.lang.String taxB, java.lang.String taxC, java.lang.String taxD, java.lang.String taxE, java.lang.String taxF, java.lang.String taxG, java.lang.String taxH) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    53h (83) ESTABLISHMENT OF DECIMATES, CURRENCY AND TAX RATES
    Specified by:
      `command83Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `multiplier` - Multiplier - between 0 and 3 and shows the power of 10 before multiply by the input or output number. It is currently disabled and is not used.
      `decimals` - This is a byte with a value between 0 and 2 and shows the location where to put the decimal point. *
      `currency` - The name of the currency. Up to 3 bytes.
      `enabledT` - 8 bytes with possible value '0' or '1', determining whether the respective tax group is disabled ('0') or * enabled ('1').
      `taxA` - The value of tax rates.
      `taxB` -
      `taxC` -
      `taxD` -
      `taxE` -
      `taxF` -
      `taxG` -
      `taxH` -
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command83Variant1Version0

    public FiscalResponse command83Variant1Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    53h (83) READING OF DECIMALS, CURRENCY AND TAX RATES
    Specified by:
      `command83Variant1Version0` in class `FiscalDeviceV1`
    Returns:
      Multiplier, Decimals, Currency_name, EnabledT, TaxA, TaxB, TaxC, TaxD,â€¦
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command84Variant0Version0

    public FiscalResponse command84Variant0Version0​(java.lang.String bcType, java.lang.String bcData, java.lang.String sPrintBCdata) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    54H (84) BARCODE PRINT - no text containing the barcode is printed.
    Specified by:
      `command84Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `bcType` - - Barcode type '1' - EAN8, '2' - EAN13k '3' - Code 128.
      `bcData` - Barcode data. Depending on the type of barcode. EAN8 - 7 digits. The checksum (8 digits) is calculated by the device, EAN13 - 12 digits. The checksum (12 digits) is calculated by the device, Code128 - Up to 30 characters.
      `sPrintBCdata` -
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command85Variant0Version0

    public FiscalResponse command85Variant0Version0​(java.lang.String option, java.lang.String name) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    55H (85) PROGRAMMING NAMES OF PAYMENTS
    Specified by:
      `command85Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `option` - 'N' Payment 1 'C' Payment 2 'D' Payment 3 'I' Payment 4 'J' Payment 5
      `name` - Name of the respective payment type (up to 24 characters).
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command85Variant1Version0

    public FiscalResponse command85Variant1Version0​(java.lang.String option) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    55H (85) READING THE NAMES OF PAYMENTS
    Specified by:
      `command85Variant1Version0` in class `FiscalDeviceV1`
    Returns:
      - Name - Name of the respective payment type (up to 10 characters).
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command86Variant0Version0

    public FiscalResponse command86Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    56H (86) READING THE DATE OF THE LATEST RECORD IN FISCAL MEMORY
    Specified by:
      `command86Variant0Version0` in class `FiscalDeviceV1`
    Returns:
      _ DT - DD-MM-YYYY
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command86Variant1Version0

    public FiscalResponse command86Variant1Version0​(java.lang.String Option, java.lang.String Number) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    56H (86) READING THE DATE OF THE LATEST RECORD IN FISCAL MEMORY
    Specified by:
      `command86Variant1Version0` in class `FiscalDeviceV1`
    Parameters:
      `Option` - - Optional parameter * If missing, the date of the last entry in the FI is returned. * 'T' - Returns the time of the last recording. * 'R' - Read a registration record. * 'D' - Read deregistration entry.
      `Number` - - Optional parameter for 'R' and 'D' options only. Serial number of the registration / deregistration record decimal number 1 - 10. If missing, the number of registrations / deregistrations so far is returned.
    Returns:
      Date or DateTime[,RegNumber] or Cnt or F
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command87Variant0Version0

    public FiscalResponse command87Variant0Version0​(java.lang.String dept, java.lang.String taxGr, java.lang.String line1, java.lang.String line2) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    57H (87) DEPARTMENT NAME PROGRAMMING
    Specified by:
      `command87Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `dept` - Department number. Integer from 1 to 9.
      `taxGr` - Tax group associated with the department.
      `line1` - Name or text for the department. Up to 22 characters.
      `line2` - Name or text for the department - second line. Optional parameter - up to 22 characters.
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command88Variant0Version0

    public FiscalResponse command88Variant0Version0​(java.lang.String dept) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    58H (88) RECEIPT OF DATA ON ACCUMULATED AMOUNTS FOR DEPARTMENT
    Specified by:
      `command88Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `dept` -
    Returns:
      - ExitCode- One byte with possible values: 'F' The department is not programmed. There is no data about him. 'P' The department is programmed. The following information about it follows. TaxGr - Tax Group of the Department. RecSales - is always 1. RecSum - Accumulated amount for the current fiscal receipt for the respective one department. Floating number with two decimal places. TotSales - is always 1. TotSum - Accumulated amount for the day for the respective department. Floating number with two decimal places. Line - Name or text for the department.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command89Variant0Version0

    public FiscalResponse command89Variant0Version0​(java.lang.String testType) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    59h (89) PROGRAMMING OF THE PRODUCTION TEST AREA
    Specified by:
      `command89Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `testType` - If it is 'T' it is recorded in the FM, otherwise there is no record, only the parameters are returned.
    Returns:
      _ P (50h) No error. F (46h) There is an error. Free The number of other free blocks to record such blocks. 4 bytes.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command90Variant0Version0

    public FiscalResponse command90Variant0Version0​(java.lang.String option) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    5Ah (90) READING DIAGNOSTIC INFORMATION
    Specified by:
      `command90Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `option` - At value '1' - a checksum is calculated the code memory (firmware), otherwise returns 'FFFF '.
    Returns:
      _ Name - Name of FD. FwRev - Software version. 4 bytes. FwDate - The date of the DDMmmYY software. 7 bytes. FwTime - Time of HHMM software. 4 bytes. Chk - EPROM checksum. 4 bytes string in hexadecimal. For example, if the checksum is 214Ah, it will be transmitted 32h, 31h, 34h, 41h. Sw - Not supported by FI. Ser - Individual device number - 8 bytes. FM - Fiscal module number - 8 bytes.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command92Variant0Version0

    public FiscalResponse command92Variant0Version0​(java.lang.String type) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    5Ch (92) PRINT SEPARATION LINE
    Specified by:
      `command92Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `type` - '1' Fill with the symbol '-'. '2' Fill in sequentially with the symbols '-' and ''. '3' Fill with the symbol '='. '4' Fill with the double-width symbol '*'
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command92Variant1Version0

    public FiscalResponse command92Variant1Version0​(java.lang.String type) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    5Ch (92) PRINT SEPARATION LINE
    Specified by:
      `command92Variant1Version0` in class `FiscalDeviceV1`
    Parameters:
      `type` - 0 to 3 (bit mask) 0 - Unconditionally add the inscription "no payment due!" With triple height. 1 - adds the inscription "on this receipt". 2 - adds a frame of the double width symbol '*' at the top and bottom. The command is supported only in service receipts!
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command93Variant1Version0

    public FiscalResponse command93Variant1Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    5Dh (93) RECEIPT OF INFORMATION ABOUT DISCOUNTS AND SURCHARGER FOR THE DAY
    Specified by:
      `command93Variant1Version0` in class `FiscalDeviceV1`
    Returns:
      - CntD - Number of discounts after the last Z-report. SumD - Amount of discounts after the last Z-report. CntM - Number of surcharges after the last Z-report. SumM - Amount of surcharges after the last Z-report.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command94Variant0Version0

    public FiscalResponse command94Variant0Version0​(java.lang.String SHA1, java.lang.String SkipZ, java.lang.String startDate, java.lang.String endDate) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    5Eh (94) FULL FM REPORT BY DATE
    Specified by:
      `command94Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `SHA1` - Optional argument - one byte with value '#'. If present, for each Z-report also prints the checksum according to SHA-1 algorithm. SkipZ Optional argument - one byte with value '*'. If present, for each Z-report print only the tax rates for which the accumulated amounts for the day are non-zero. Such report is non-standard and can be used only for internal inquiries of the site!
      `startDate` - The start date of the fiscal record. 6 bytes (DDMMYY).
      `endDate` - Fiscal record end date. 6 bytes (DDMMYY).
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command94Variant1Version0

    public FiscalResponse command94Variant1Version0​(java.lang.String SHA1, java.lang.String SkipZ, java.lang.String startDate) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    5Eh (94) FULL FM REPORT BY DATE MONTHLY OR ANNUALLY
    Specified by:
      `command94Variant1Version0` in class `FiscalDeviceV1`
    Parameters:
      `startDate` - The start date of the fiscal record. Month - 4 bytes (MMYY) for monthly report. Year - 2 bytes (YY) for annual report.
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command95Variant0Version0

    public FiscalResponse command95Variant0Version0​(java.lang.String first, java.lang.String last) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    5Fh (95) SHORT REPORT OF FM BY BLOCKS
    Specified by:
      `command95Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `first` - Initial number of fiscal record.
      `last` - End number of fiscal record.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command97Variant0Version0

    public FiscalResponse command97Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    61h (97) READING OF ESTABLISHED TAX RATES
    Specified by:
      `command97Variant0Version0` in class `FiscalDeviceV1`
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command98Variant0Version0

    public FiscalResponse command98Variant0Version0​(java.lang.String text, java.lang.String name) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    62h (98) ESTABLISHMENT OF THE EIK (UIC)
    Specified by:
      `command98Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `text` - These are up to 14 bytes containing UIC as text.
      `name` - This is the comment text before the UIC. The default is "UIC".
    Returns:
      - Result - 'P' No error 'F' Error.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command99Variant0Version0

    public FiscalResponse command99Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    63h (99) READING OF THE EIK (UIC)
    Specified by:
      `command99Variant0Version0` in class `FiscalDeviceV1`
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command100Variant0Version0

    public FiscalResponse command100Variant0Version0​(java.lang.String text) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    (100) DISPLAY TEXT ON THE CUSTOMER DISPLAY
    Specified by:
      `command100Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `text` - Text up to 40 characters that is sent to the display. If it is necessary to transmit ASCII characters less than 20h (control sequences) they increase by 40h and are preceded by 10h. Example: to transmit 1Bh, 4Bh, 00h in the data field is recorded 10h, 5Bh, 4Bh, 10h, 40h.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command101Variant0Version0

    public FiscalResponse command101Variant0Version0​(java.lang.String operatorCode, java.lang.String oldPassword, java.lang.String newPassword) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    65h (101) SET OPERATOR PASSWORD
    Specified by:
      `command101Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `operatorCode` - Operator code. From 1 to 16.
      `oldPassword` - Old password (1 to 8 digits).
      `newPassword` - New password (1 to 8 digits).
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command102Variant0Version0

    public FiscalResponse command102Variant0Version0​(java.lang.String operatorCode, java.lang.String operatorPass, java.lang.String operatorName) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    66h (102) SET OPERATOR NAME
    Specified by:
      `command102Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `operatorCode` - Operator code. From 1 to 30.
      `operatorPass` - Password (1 to 8 digits).
      `operatorName` - Name of the operator (up to 24 characters).
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command103Variant0Version0

    public FiscalResponse command103Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    67h (103) CURRENT RECEIPT INFORMATION
    Specified by:
      `command103Variant0Version0` in class `FiscalDeviceV1`
    Returns:
      _FiscalResponse

      CanVd: Is it possible to return (sale with a negative sign) [0/1] TaxA: Accumulated amount by tax group A TaxB: Accumulated amount by tax group B TaxC: Accumulated amount by tax group B TaxD: Accumulated amount by tax group D TaxE: Accumulated amount by tax group E TaxF: Accumulated amount by tax group E TaxG: Accumulated amount by tax group G TaxH: Accumulated amount by tax group H Inv: Is an extended client note open? InvNum - Number of the next invoice (number 10 items). Type - Type of receipt. '0' - Fiscal. '1' - Reversal (storno) operator error. '2' - Reversal (storno) / Complaint. '3' - Reversal (storno) of tax reduction. basis

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command105Variant0Version0

    public FiscalResponse command105Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    69h (105) OPERATORS REPORT
    Specified by:
      `command105Variant0Version0` in class `FiscalDeviceV1`
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command106Variant0Version0

    public FiscalResponse command106Variant0Version0​(java.lang.String mSec) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    6Ah (106) OPENING A DRAWER
    Specified by:
      `command106Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `mSec` - Pulse length in milliseconds (5-100)
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command107Variant0Version0

    public FiscalResponse command107Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    6Bh (107) DEFINING AND READING ARTICLES (PLU) Information about the items
    Specified by:
      `command107Variant0Version0` in class `FiscalDeviceV1`
    Returns:
      _ Total - Total number of programmable items. Progr - Number of programmed items. Len - Maximum length of item name.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command107Variant1Version0

    public FiscalResponse command107Variant1Version0​(java.lang.String taxGr, java.lang.String PLU, java.lang.String group, java.lang.String price, java.lang.String replaceQty, java.lang.String quantity, java.lang.String name) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    6Bh (107) DEFINING AND READING ARTICLES (PLU)

    Item programming.

    Specified by:
      `command107Variant1Version0` in class `FiscalDeviceV1`
    Parameters:
      `taxGr` - Tax group ('A', 'B', 'C', 'D' ...)
      `PLU` - Article Number (1 to 999999999)
      `group` - Stock group (1 to 9)
      `price` - Unit price. Up to 8 significant digits.
      `replaceQty` - Optional parameter - one byte with value 'A'. Changes the value of the next parameter (Quantity).
      `quantity` - Number with up to 3 decimal places - the available quantity for the given one article. FD does not maintain quantity and returns 0.000
      `name` - Item name. Up to 36 bytes.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command107Variant2Version0

    public FiscalResponse command107Variant2Version0​(java.lang.String PLU, java.lang.String quantity) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    6Bh (107) DEFINING AND READING ARTICLES (PLU) Change the available quantity for an item.
    Specified by:
      `command107Variant2Version0` in class `FiscalDeviceV1`
    Parameters:
      `PLU` -
      `quantity` -
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command107Variant3Version0

    public FiscalResponse command107Variant3Version0​(java.lang.String option, java.lang.String PLU, java.lang.String toPLU) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    6Bh (107) DEFINING AND READING ARTICLES (PLU) Delete an item.
    Specified by:
      `command107Variant3Version0` in class `FiscalDeviceV1`
    Parameters:
      `option` - 'A' All items with non-zero accumulated amounts are deleted.
      `PLU` - Deletes the item with the specified number if there are no accumulated amounts.
      `toPLU` - Delete items next to instructions.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command107Variant4Version0

    public FiscalResponse command107Variant4Version0​(java.lang.String PLU) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    6Bh (107) DEFINING AND READING ARTICLES (PLU) Read item data.
    Specified by:
      `command107Variant4Version0` in class `FiscalDeviceV1`
    Parameters:
      `PLU` - Article number. Between 1 and 999999999.
    Returns:
      -

      Result - P, F PLU Item number. Between 1 and 999999999. TaxGr - Tax Group. One byte. Grp - Commodity Group. From 1 to 9. SPrice - Unit price. Floating number with decimal places current for FD. Total - Accumulated amount for the given item. Sold - Sold quantity. Floating number with 3 decimal places. Avail - Quantity available. FDdoes not maintain quantity and returns 0.000 Name - Name of the item. Up to 22 bytes. - One byte 'F' is returned if an item is not found.

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command107Variant5Version0

    public FiscalResponse command107Variant5Version0​(java.lang.String startPLU) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    6Bh (107) DEFINING AND READING ARTICLES (PLU) Return data for the first programmed item or FTT found.
    Specified by:
      `command107Variant5Version0` in class `FiscalDeviceV1`
    Parameters:
      `startPLU` - Article number. Between 1 and 999999999.
    Returns:
      _ Result - P, F\ PLU - Item number. Between 1 and 999999999. TaxGr - Tax Group. One byte. Grp - Commodity Group. From 1 to 9. SPrice - Unit price. Floating number with decimal places current for FD. Total - Accumulated amount for the given item. Sold - Sold quantity. Floating number with 3 decimal places. Avail - Quantity available. FDdoes not maintain quantity and returns 0.000 Name - Name of the item. Up to 22 bytes. - One byte 'F' is returned if an item is not found.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command107Variant6Version0

    public FiscalResponse command107Variant6Version0​(java.lang.String lastPLU) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    6Bh (107) DEFINING AND READING ARTICLES (PLU) Return the data for the last found programmed item.
    Specified by:
      `command107Variant6Version0` in class `FiscalDeviceV1`
    Parameters:
      `lastPLU` - Article number. Between 1 and 999999999.
    Returns:
      _ Result - P, F PLU Item number. Between 1 and 999999999. TaxGr - Tax Group. One byte. Grp - Commodity Group. From 1 to 9. SPrice - Unit price. Floating number with decimal places current for FD. Total - Accumulated amount for the given item. Sold - Sold quantity. Floating number with 3 decimal places. Avail - Quantity available. FDdoes not maintain quantity and returns 0.000 Name - Name of the item. Up to 22 bytes. -One byte 'F' is returned if an item is not found.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command107Variant7Version0

    public FiscalResponse command107Variant7Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    6Bh (107) DEFINING AND READING ARTICLES (PLU) Return the data for the next found programmed item
    Specified by:
      `command107Variant7Version0` in class `FiscalDeviceV1`
    Returns:
      - Result - P, F PLU Item number. Between 1 and 999999999. TaxGr - Tax Group. One byte. Grp - Commodity Group. From 1 to 9. SPrice - Unit price. Floating number with decimal places current for FD. Total - Accumulated amount for the given item. Sold - Sold quantity. Floating number with 3 decimal places. Avail - Quantity available. FDdoes not maintain quantity and returns 0.000 Name - Name of the item. Up to 22 bytes. - One byte 'F' is returned if an item is not found.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command107Variant8Version0

    public FiscalResponse command107Variant8Version0​(java.lang.String startPLU) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    6Bh (107) DEFINING AND READING ARTICLES (PLU) Return the data for the first found item with sales on it
    Specified by:
      `command107Variant8Version0` in class `FiscalDeviceV1`
    Parameters:
      `startPLU` - Article number. Between 1 and 999999999. If the PLU parameter is set, then the search starts from it in ascending direction, otherwise start from 1.
    Returns:
      - Result - P, F PLU - Item number. Between 1 and 999999999. TaxGr - Tax Group. One byte. Grp - Commodity Group. From 1 to 9. SPrice - Unit price. Floating number with decimal places current for FD. Total - Accumulated amount for the given item. Sold - Sold quantity. Floating number with 3 decimal places. Avail - Quantity available. FDdoes not maintain quantity and returns 0.000 Name - Name of the item. Up to 22 bytes. -One byte 'F' is returned if an item is not found.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command107Variant9Version0

    public FiscalResponse command107Variant9Version0​(java.lang.String startPLU) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    6Bh (107) DEFINING AND READING ARTICLES (PLU) Return data for the last found item with sales on it.
    Specified by:
      `command107Variant9Version0` in class `FiscalDeviceV1`
    Returns:
      - Result- P, F PLU - Item number. Between 1 and 999999999. TaxGr - Tax Group. One byte. Grp - Commodity Group. From 1 to 9. SPrice - Unit price. Floating number with decimal places current for FD. Total - Accumulated amount for the given item. Sold - Sold quantity. Floating number with 3 decimal places. Avail - Quantity available. FDdoes not maintain quantity and returns 0.000 Name - Name of the item. Up to 22 bytes. -One byte 'F' is returned if an item is not found.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command107Variant10Version0

    public FiscalResponse command107Variant10Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    6Bh (107) DEFINING AND READING ARTICLES (PLU) Return data for the next found item with sales on it.
    Specified by:
      `command107Variant10Version0` in class `FiscalDeviceV1`
    Returns:
      _ Result P, F PLU Item number. Between 1 and 999999999. TaxGr Tax Group. One byte. Grp Commodity Group. From 1 to 9. SPrice Unit price. Floating number with decimal places current for FD. Total Accumulated amount for the given item. Sold Sold quantity. Floating number with 3 decimal places. Avail Quantity available. FD does not maintain quantity and returns 0.000 Name Name of the item. Up to 22 bytes. One byte 'F' is returned if an item is not found.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command107Variant11Version0

    public FiscalResponse command107Variant11Version0​(java.lang.String option, java.lang.String startPLU) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    6Bh (107) DEFINING AND READING ARTICLES Find a free (unprogrammed) item.
    Specified by:
      `command107Variant11Version0` in class `FiscalDeviceV1`
    Parameters:
      `option` - 'X' Find the first free (unprogrammed) item. If the PLU parameter is set, the first free (unprogrammed) item with a number greater than or equal to it is returned. If missing, default is PLU = 1. 'X' Find the last available (unprogrammed) item.
      `startPLU` -
    Returns:
      _ PLU - If the startPLU parameter is set, it returns the first free (unprogrammed) item with a number greater than or equal to him. If missing, default is PLU = 1.
    Throws:
      `java.io.IOException`
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command107Variant12Version0

    public FiscalResponse command107Variant12Version0​(java.lang.String PLU, java.lang.String price) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    6Bh (107) DEFINING AND READING ARTICLES Set the price of an item
    Specified by:
      `command107Variant12Version0` in class `FiscalDeviceV1`
    Parameters:
      `PLU` - Article Number (1 to 999999999)
      `price` - Unit price. Up to 8 significant digits.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command108Variant0Version0

    public FiscalResponse command108Variant0Version0​(java.lang.String option) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    6Ch (108) EXTENDED DAILY FINANCIAL REPORT The command has the same syntax as command 69 (45H), * but at the beginning of the daily report a report of * items for which there are sales for the day.
    Specified by:
      `command108Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `option` - '0' Z-report is printed. The printout ends with the inscription "FISCAL RECEIPT ". '2' A daily financial report is made without resetting (ie no entry is made in fiscal memory and register reset). The printout ends with a logo "NON FISCAL RECEIPT".

      The presence of the symbol N at the end of the data prohibits the clearing of the accumulated ones data by operators in a reset report.

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command109Variant0Version0

    public FiscalResponse command109Variant0Version0​(java.lang.String count) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    6Dh (109) DUPLICATE RECEIPT PRINT
    Specified by:
      `command109Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `count` - Number of duplicate receipts (only value 1 is accepted!).
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command110Variant0Version0

    public FiscalResponse command110Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    6Eh (110) ADDITIONAL INFORMATION FOR THE DAY
    Specified by:
      `command110Variant0Version0` in class `FiscalDeviceV1`
    Returns:
      - Cash - Paid in cash Credit - On credit (Additional payment 1) Debit - With debit card (Additional payment 2) Check - Paid by check (Additional payment 3) Pay4 - Additional payment 4 Pay5 - Additional payment 5 Pay6 Additional payment 6 Closure - Current (last) fiscal record Receipt - Number of the next fiscal receipt
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command111Variant0Version0

    public FiscalResponse command111Variant0Version0​(java.lang.String reportType, java.lang.String firstPLU, java.lang.String lastPLU, java.lang.String group) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    6Fh (111) ARTICLE (PLU) REPORT
    Specified by:
      `command111Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `reportType` - Specifies the type of information to be printed. Possible values: 'S' Only items with sales for the day are printed. The item number is printed for each item, the tax group, the name, the quantity sold and the turnover. 'P' All programmed items are printed, with item number, tax group, product group, name, barcode, affiliation to a department, type of programmed price and unit price.
      `firstPLU` - - Start number of the item to be included in the report. The default is 1.
      `lastPLU` - - Last item number to include in the report. The default is 999999999. Group Number from 1 to 9. If this parameter is set, only the items from this group are included in the report, in otherwise all groups are printed. The items are sorted by number. In case of daily financial report with resetting, the accumulated amounts by items are reset if apparently not specified to be preserved.
      `group` - Number from 1 to 9. If this parameter is set, only the items from this group are included in the report, in otherwise all groups are printed. The items are sorted by number. In case of daily financial report with resetting, the accumulated amounts by items are reset if apparently not specified to be preserved.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command112Variant0Version0

    public FiscalResponse command112Variant0Version0​(java.lang.String operator) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    70h (112) RECEIVING OPERATOR INFORMATION
    Specified by:
      `command112Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `operator` - Operator number (1 to 30).
    Returns:
      - Operator - Operator number (1 to 30). Receipts - Number of fiscal receipts issued by the operator. Total - Number of sales and total accumulated amount divided by ';'. Discount - Number of discounts and total amount of discounts divided by ';'. Surcharge - Number of allowances and total allowances divided by ';'. Void - Number of corrections and total amount of corrections divided by ';'. Name - Name of the operator. Password - Operator password. Returns only if the FD has a service jumper installed.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command112Variant1Version0

    public FiscalResponse command112Variant1Version0​(java.lang.String operator) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    70h (112) RECEIVING OPERATOR INFORMATION - Reversal (storno) information.
    Specified by:
      `command112Variant1Version0` in class `FiscalDeviceV1`
    Parameters:
      `operator` - Operator number (1 to 30).
    Returns:
      - ErrCode - One byte error code. 'P' - The command was executed successfully. Data follows. 'F' - Error. Name - Name of the operator. Password - Operator password. Only if a service jumper is fitted. STRReceipts - Number of reversal receipts issued by the operator. STRTotal - Number of reversals and total accumulated amount. STRReturn - Number of reversal return / claim and total accumulated amount of return / claim. STRError - Number of reversal operator error and total accumulated amount of operator error. STRTaxbase - Number of reversal of the tax base reduction and total accumulated amount from the tax base reduction.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command113Variant0Version0

    public FiscalResponse command113Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    71h (113) READ NUMBER OF THE LAST PRINTED DOCUMENT
    Specified by:
      `command113Variant0Version0` in class `FiscalDeviceV1`
    Returns:
      DocNum - Number of the last issued document (7 digits).
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command114Variant0Version0

    public FiscalResponse command114Variant0Version0​(java.lang.String Rec1) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Information about the active tax rates for the specified Z-report record.
    Specified by:
      `command114Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `Rec1` - Record number from FM.
    Returns:
      -

      ErrorCode One byte with value: â€¢ 'P' Data is valid. â€¢ 'F' Invalid record checksum. No data. â€¢ 'E' No such entry. No data. DecRec - Last (active) entry with tax rates. DecimalsCount Number of decimal places for the specified Z-report record. VATEnabled - Allowed tax rates - 8 bytes with '0' or '1', where '1' means 'allowed'. PercX - Tax rate for the respective tax group in percentages. DT - Date and time of the data in the format: DD-MM-YY hh: mm: ss.

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command114Variant1Version0

    public FiscalResponse command114Variant1Version0​(java.lang.String closure1, java.lang.String closure2) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Turnover information for the specified record or period.
    Specified by:
      `command114Variant1Version0` in class `FiscalDeviceV1`
    Parameters:
      `closure1` - FM record number.
      `closure2` - Record number from FM.
    Returns:
      _

      ErrorCode One byte with value: â€¢ 'P' Data is valid. â€¢ 'F' Invalid record checksum. No data. â€¢ 'E' No such entry. No data. DecRec Last (active) entry with tax rates. DecimalsCount Number of decimal places for the specified Z-report record. VATEnabled Allowed tax rates - 8 bytes with st-st '0' or '1', where '1' means 'allowed'. PercX Tax rate for the respective tax group in percentages. DT Date and time of the data in the format: DD-MM-YY hh: mm: ss.

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command114Variant2Version0

    public FiscalResponse command114Variant2Version0​(java.lang.String closure1, java.lang.String closure2) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Information on net amounts for the specified record or period.
    Specified by:
      `command114Variant2Version0` in class `FiscalDeviceV1`
    Parameters:
      `closure1` - FP record number.
      `closure2` - Record number from FP.
    Returns:
      _

      ErrorCode One byte with value: â€¢ 'P' Data is valid. â€¢ 'F' Invalid record checksum. No data. â€¢ 'E' No such entry. No data. Closure - Number of fiscal records for the specified period. Receipts - Number of receipts. TotX - Turnover for the respective tax group.

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command114Variant3Version0

    public FiscalResponse command114Variant3Version0​(java.lang.String closure1, java.lang.String closure2) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Information on the charged VAT for the specified record or period.
    Specified by:
      `command114Variant3Version0` in class `FiscalDeviceV1`
    Parameters:
      `closure1` - FP record number.
      `closure2` - Record number from FP.
    Returns:
      -

      ErrorCode One byte with value: 'P' Data is valid. 'F' Invalid record checksum. No data. 'E' No such entry. No data. DecRec - Last (active) entry with tax rates. DecimalsCount - Number of decimal places for the specified Z-report record. VATEnabled - Allowed tax rates - 8 bytes with '0' or '1', where '1' means 'allowed'. PercX - Tax rate for the respective tax group in percentages. DT - Date and time of the data in the format: DD-MM-YY hh: mm: ss.

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command114Variant4Version0

    public FiscalResponse command114Variant4Version0​(java.lang.String closure1) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Additional information about the specified entry.
    Specified by:
      `command114Variant4Version0` in class `FiscalDeviceV1`
    Parameters:
      `closure1` - FP record number.
    Returns:
      _

      ErrorCode One byte with value: 'P' Data is valid. 'F' Invalid record checksum. No data. 'E' No such entry. No data. DecRec - Last (active) entry with tax rates. DecimalsCount - Number of decimal places for the specified Z-report record. VATEnabled - Allowed tax rates - 8 bytes with st-st '0' or '1', where '1' means 'allowed'. PercX - Tax rate for the respective tax group in percentages. DT - Date and time of the data in the format: DD-MM-YY hh: mm: ss.

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command114Variant5Version0

    public FiscalResponse command114Variant5Version0​(java.lang.String closure1) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Information about the specified entry from the fiscal memory for setting tax rates
    Specified by:
      `command114Variant5Version0` in class `FiscalDeviceV1`
    Parameters:
      `closure1` - FM record number.
    Returns:
      -

      ErrorCode One byte with value: 'P' Data is valid. 'F' Invalid record checksum. No data. 'E' No such entry. No data. DecimalsCount - Number of decimal places for the specified Z-report record. VATEnabled - Allowed tax rates - 8 bytes with '0' or '1', where '1' means 'allowed'. PercX - Tax rate for the respective tax group in percentages. DT -Date and time of the data in the format: DD-MM-YY hh: mm: ss.

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command114Variant6Version0

    public FiscalResponse command114Variant6Version0​(java.lang.String closure1) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Information about the specified FM record with RAM reset.
    Specified by:
      `command114Variant6Version0` in class `FiscalDeviceV1`
    Parameters:
      `closure1` - FM record number.
    Returns:
      -

      ErrorCode One byte with value: 'P' - The command was executed successfully. Data follows. 'F' - Invalid record checksum. No data. 'E' - No such entry. No data. DT- Date and time of data in format: DD-MM-YY hh: mm: ss.

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command114Variant7Version0

    public FiscalResponse command114Variant7Version0​(java.lang.String closure1, java.lang.String closure2) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Information about the amounts by type of payment for the specified record or period
    Specified by:
      `command114Variant7Version0` in class `FiscalDeviceV1`
    Parameters:
      `closure1` - FP record number.
      `closure2` - Record number from FP.
    Returns:
      _

      ErrorCode One byte with value: 'P' - The command was executed successfully. Data follows. 'F' - Invalid record checksum. No data. 'E' - No such entry. No data. CashP - Paid in cash. CardP - Paid with debit card. CredP - Paid by credit card. CheqP - Paid by check. APaydx - Additional payment types

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command114Variant8Version0

    public FiscalResponse command114Variant8Version0​(java.lang.String closure1, java.lang.String closure2) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Information about the amounts by type of payment for the specified record or period.
    Specified by:
      `command114Variant8Version0` in class `FiscalDeviceV1`
    Parameters:
      `closure1` - FP record number.
      `closure2` - Record number from FP.
    Returns:
      _

      ErrorCode One byte with value: 'P' - The command was executed successfully. Data follows. 'F' - Invalid record checksum. No data. 'E' - No such entry. No data. DiscC - Number of discounts DiscS - Accumulated amount of discounts MkUpC - Number of allowances MkUpS - Accumulated amount of allowances VoidC - Number of corrections VoidS - Total amount of adjustments. CanC - Number of canceled receipts CanS - Total amount of canceled vouche

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command114Variant9Version0

    public FiscalResponse command114Variant9Version0​(java.lang.String closure1, java.lang.String closure2) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Information about the amounts by type of payment for the specified record or period. Cash-In Cash-Out.
    Specified by:
      `command114Variant9Version0` in class `FiscalDeviceV1`
    Parameters:
      `closure1` - FP record number.
      `closure2` - Record number from FP.
    Returns:
      _

      ErrorCode One byte with value: 'P' - The command was executed successfully. Data follows. 'F' - Invalid record checksum. No data. 'E' - No such entry. No data. InC Number of Cash-In InS Amount of Cash-In OutC Number of Cash-Out OutS Amount of Cash-Out

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command114Variant10Version0

    public FiscalResponse command114Variant10Version0​(java.lang.String closure1) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Information on the total turnover and VAT up to the specified Z-report
    Specified by:
      `command114Variant10Version0` in class `FiscalDeviceV1`
    Parameters:
      `closure1` - FP record number.
    Returns:
      _

      ErrorCode One byte with value: 'P' - The command was executed successfully. Data follows. 'F' - Invalid record checksum. No data. 'E' - No such entry. No data. GTotal - Accumulated turnover up to and including the specified daily report. GVAT - Accumulated VAT up to and including the specified daily report.

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command115Variant0Version0

    public FiscalResponse command115Variant0Version0​(java.lang.String rowNum, java.lang.String data) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    73h (115) GRAPHIC LOGO PROGRAMMING
    Specified by:
      `command115Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `rowNum` - Shows the row we are programming. Number from 0 to 95.
      `data` - Graphic data. Set to hexadecimal, two characters for each byte of information. The length of the data is up to 54 bytes, if any less, automatically topped up with 00.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command115Variant1Version0

    public FiscalResponse command115Variant1Version0​(java.lang.String rowNum) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    73h (115) READING A GRAPHIC LOGO
    Specified by:
      `command115Variant1Version0` in class `FiscalDeviceV1`
    Parameters:
      `rowNum` - Shows the row we are programming. Number from 0 to 95.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command117Variant0Version0

    public FiscalResponse command117Variant0Version0​(java.lang.String Reset) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    75h (117) DAILY FINANCIAL STATEMENT WITH PRINT OF DATA BY DEPARTMENT
    Specified by:
      `command117Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `Reset` -
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command118Variant0Version0

    public FiscalResponse command118Variant0Version0​(java.lang.String Reset) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    76h (118) DAILY FINANCIAL REPORT WITH DEPARTMENT AND PLU PRINTING

    The command is identical to 69 (45h) from the previous version, the only difference being that, at the top of the daily report, it additionally prints the departments having sales for the day and the PLUs with codes between 1 and 40, if they have sales. Command 69 is left unchanged. Commands 69, 108, 117 and 118 with option '0' (daily financial report with reset) reset the accumulated department data as well.

    Specified by:
      `command118Variant0Version0` in class `FiscalDeviceV1`
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command119Variant0Version0

    public FiscalResponse command119Variant0Version0​(java.lang.String Flg, java.lang.String DT1, java.lang.String DT2) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    77h (119) WORK WITH ELECTRONIC JOURNAL Read data Returns the first line of a document with date and time DT1 and sets the end of the search for a document with date and time DT2 (inclusive). There is filtering of the documents that are selected in dependence on the Flg argument.
    Specified by:
      `command119Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `Flg` - Character specifying the type of document to select for reading: 'A' All types of documents.
      `DT1` - Start date and time of the report in DDMMYY format [hhmmss]. If the hour is missed, it means "000000", ie 00:00:00.
      `DT2` - End date and time of the report in DDMMYY format [hhmmss]. If the hour is missed, it means "235959", ie 23:59:59.
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command119Variant1Version0

    public FiscalResponse command119Variant1Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    77h (119) EJ OPERATION Reading the next text line by EJ.
    Specified by:
      `command119Variant1Version0` in class `FiscalDeviceV1`
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command124Variant0Version0

    public FiscalResponse command124Variant0Version0​(java.lang.String DocType, java.lang.String BegDate, java.lang.String EndDate) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    7Ch (124) READING EJ Search EJ by date and time.

    Specified by:
      `command124Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `DocType` - - Type of documents searched. '0' - All. '1' - Fiscal receipts (all fiscal receipts, sale, reversal, invoice, reversal invoice (kr. Notice), daily financial report (Z report)). '2' - Daily Z report. '3' - Cash-in. '4' - Cash-out. '5' - Daily X report. '6' - Service receipts (all except those listed in option 1). '7' - Invoice. '8' - Reversal (storno) of fiscal receipts. '9' - Reversal (storno) invoice (cr. Notice).
      `BegDate` - - Start date (date and time) for searching documents. 6/12 digits (DDMMYY or DDMMYYhhmmss format).
      `EndDate` - - End date (date and time) for searching documents. 6/12 digits (DDMMYY or DDMMYYhhmmss format).
    Returns:
      - FirstDoc - Number of the first found document (number 0 - 9999999). LastDoc - Number of the last found document (number 0 - 9999999);
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command124Variant1Version0

    public FiscalResponse command124Variant1Version0​(java.lang.String DocType, java.lang.String BegZ, java.lang.String EndZ) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    7Ch (124) EJ READING - Search EJ by Z report number.

    Specified by:
      `command124Variant1Version0` in class `FiscalDeviceV1`
    Parameters:
      `DocType` - - Type of documents searched. '0' - All. '1' - Fiscal receipts (all fiscal receipts, sale, reversal, invoice, reversal invoice (kr. Notice), daily financial report (Z report)). '2' - Daily Z report. '3' - Cash-in. '4' - Cash-out. '5' - Daily X report. '6' - Service receipts (all except those listed in option 1). '7' - Invoice. '8' - Reversal (storno) of fiscal receipts. '9' - Reversal (storno) invoice (cr. Notice).
      `BegZ` - - Number of Z report to start the search range. Number (1..1825).
      `EndZ` - - The number of the Z report for the end of the search range. Number (1..1825).
    Returns:
      - FirstDoc - Number of the first found document (number 0 - 9999999). LastDoc - Number of the last found document (number 0 - 9999999);
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command124Variant2Version0

    public FiscalResponse command124Variant2Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    7Ch (124) READING A EJ Information about EJ
    Specified by:
      `command124Variant2Version0` in class `FiscalDeviceV1`
    Returns:
      - ErrCode - One byte error code. 'P' - The command was executed successfully. 'F' - Error.

      isValid - Flag SD card contains a valid EJ. '1' - There is a valid EJ on the map. '0' - No valid EJ is recognized on the card.

      â€¢ isCurrent - Flag MAP on SD card is the current MAP on FD. '1' - EJ is current for the device. '0' - EJ is "Old" or from another device.

      IDnumber - Identification number of the device from which the EJ is. String 8 characters (format DTXXXXXX, 2 letters + 6 digits). Number - Serial number of EJ for the device. Number (0..100). DateTime - Date and time of EJ activation. String 19 characters format "DD.MM.YYYY hh: mm: ss". Serial - Serial number of the SD card. 8 characters asciihex (example AC536E00). fromZ - First Z report saved on this EJ. Number (1..1825). toZ - Last Z report saved on this EJ. Number (1..1825). fromDoc - First document saved in EJ. toDoc - Last document saved in EJ. Size - Size of EJ (SD card) in MBytes. Number up to 4000. Used - Used bytes in EJ (SD card) in MBytes. Number up to 4000.

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command125Variant0Version0

    public FiscalResponse command125Variant0Version0​(java.lang.String DocNum, java.lang.String RecType) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    7Dh (125) READING DOCUMENT DATA BY NUMBER Preparation of the document for reading.
    Specified by:
      `command125Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `RecType` - - Document type. '0' - All. '1' - Fiscal receipts (all fiscal receipts, sale, reversal, invoice, reversal invoice (kr. Notice), daily financial report (Z report)). '2' - Daily Z report. '3' - Cash-in. '4' - Cash-out. '5' - Daily X report. '6' - Service receipts (all except those listed in option 1). '7' - Invoice. '8' - Reversal (storno) of fiscal receipts. '9' - Reversal (storno) invoice (cr. Notice).
      `DocNum` - - Document number.
    Returns:
      ErrCode - One byte error code. 'P' - The command was executed successfully. 'F' - Error. DocNumber - Document number. Date - Date and time of the document. Type - Document type. '1' - Fiscal receipt for sale. '2' - Daily Z report. '3' - Cash-in. '4' - Cash-out. '5' - Daily X report. '6' - Official voucher. '7' - Invoice. '8' - Reversal (storno) of a fiscal receipt. '9' - Reversal (storno) invoice (cr. Notice). Znumber - Z report number.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command125Variant1Version0

    public FiscalResponse command125Variant1Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    7Dh (125) READING DOCUMENT DATA BY NUMBER

    Read the next line of text from the document.

    Specified by:
      `command125Variant1Version0` in class `FiscalDeviceV1`
    Returns:
      - ErrCode One byte error code. 'P' - The command was executed successfully. 'F' - Error. Text - One line of text from the document (42 ascii characters).
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command125Variant1Version2

    public FiscalResponse command125Variant1Version2() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    7Dh (125) READING DOCUMENT DATA BY NUMBER

    Read the next line with structured information from the document.

    Specified by:
      `command125Variant1Version2` in class `FiscalDeviceV1`
    Returns:
      - ErrCode One byte error code. 'P' - The command was executed successfully. 'F' - Error. Text - One line of text from the document (42 ascii characters).
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### getMAX_PLU

    public java.lang.Integer getMAX_PLU()
    Specified by:
      `getMAX_PLU` in class `FiscalDeviceV1`

  - ### getMAX_DEPARTMENT

    public java.lang.Integer getMAX_DEPARTMENT()
    Specified by:
      `getMAX_DEPARTMENT` in class `FiscalDeviceV1`

  - ### getMaxStockGroup

    public java.lang.Integer getMaxStockGroup()
    Specified by:
      `getMaxStockGroup` in class `FiscalDeviceV1`

  - ### getMaxDepartments

    public int getMaxDepartments()
    Specified by:
      `getMaxDepartments` in class `FiscalDeviceV1`

  - ### command125Variant2Version0

    public FiscalResponse command125Variant2Version0​(java.lang.String DocNum, java.lang.String RecType) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    7Dh (125) READING DOCUMENT DATA BY NUMBER Reading the next line with structures * 7Dh (125) READING DATA FROM A DOCUMENT BY NUMBER - Print the document in text on paper
    Specified by:
      `command125Variant2Version0` in class `FiscalDeviceV1`
    Parameters:
      `DocNum` - - Document number.
      `RecType` - - Document type. '0' - All. '1' - Fiscal receipts (all fiscal receipts, sale, reversal, invoice, reversal invoice (kr. Notice)). '2' - Daily Z report. '3' - Cash-in. '4' - Cash-out. '5' - Daily X report. '6' - Service receipts (all except those listed in option 1). '7' - Invoice. '8' - Reversal (storno) of fiscal receipts. '9' - Reversal (storno) invoice (cr. Notice).
    Returns:
      - ErrCode One byte error code. 'P' - The command was executed successfully. 'F' - Error. Text - One text line from the document (42 ascii characters).
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command140Variant0Version0

    public FiscalResponse command140Variant0Version0​(java.lang.String EIK, java.lang.String EIKType, java.lang.String Receiver, java.lang.String Client, java.lang.String TaxNo, java.lang.String Address_1, java.lang.String Address_2) throws java.io.IOException, FiscalException
    8Ch (140) STORAGE OF THE CLIENT'S DATA IN THE MEMORY OF FD Recording / changing customer data according to UIC. The device can store up to 1080 records with customer data.
    Specified by:
      `command140Variant0Version0` in class `FiscalDeviceV1`
    Parameters:
      `EIK` - - Buyer's UIC number. Between 9 and 13 characters.
      `EIKType` - - EIK(UIC) type. 0 - UIC Bulstat. 1 - PIN. 2 - LNC. 3 - Sl. number.
      `Receiver` - - Name of the recipient. Up to 36 characters.
      `Client` - - Name of the buyer. Up to 36 characters.
      `TaxNo` - - VAT number of the buyer. Between 10 and 14 characters.
      `Address_1` - - Buyer's address first line. Up to 36 characters.
      `Address_2` - - Buyer's address second line. Up to 36 characters.
    Returns:
      ErrCode - One byte error code. 'P' - Successful execution. 'F' - Error.
    Throws:
      `java.io.IOException`
      `FiscalException`

  - ### command140Variant1Version0

    public FiscalResponse command140Variant1Version0​(java.lang.String EIK) throws java.io.IOException, FiscalException
    8Ch (140) STORAGE OF THE CLIENT'S DATA IN THE MEMORY OF FD Deletion of EIK(UIC) customer data.
    Specified by:
      `command140Variant1Version0` in class `FiscalDeviceV1`
    Parameters:
      `EIK` -
    Returns:
      ErrCode - One byte error code. 'P' - Successful execution. 'F' - Error.
    Throws:
      `java.io.IOException`
      `FiscalException`

  - ### command140Variant2Version0

    public FiscalResponse command140Variant2Version0​(java.lang.String Seller) throws java.io.IOException, FiscalException
    8Ch (140) STORAGE OF THE CLIENT'S DATA IN THE MEMORY OF FD Record data for seller's name. Vendor field when issuing invoices.
    Specified by:
      `command140Variant2Version0` in class `FiscalDeviceV1`
    Returns:
      ErrCode - One byte error code. 'P' - Successful execution. 'F' - Error.
    Throws:
      `java.io.IOException`
      `FiscalException`

  - ### command140Variant3Version0

    public FiscalResponse command140Variant3Version0() throws java.io.IOException, FiscalException
    8Ch (140) STORAGE OF THE CLIENT'S DATA IN THE MEMORY OF FD Read the seller's name field.
    Specified by:
      `command140Variant3Version0` in class `FiscalDeviceV1`
    Returns:
      ErrCode - One byte error code. 'P' - Successful execution. 'F' - Error.
    Throws:
      `java.io.IOException`
      `FiscalException`

  - ### command140Variant4Version0

    public FiscalResponse command140Variant4Version0() throws java.io.IOException, FiscalException
    8Ch (140) STORAGE OF THE CLIENT'S DATA IN THE MEMORY OF FD Read data for the first client stored in the device's memory.
    Specified by:
      `command140Variant4Version0` in class `FiscalDeviceV1`
    Returns:
      ErrCode - One byte error code. 'P' - Successful execution. 'F' - Error.
    Throws:
      `java.io.IOException`
      `FiscalException`

  - ### command140Variant5Version0

    public FiscalResponse command140Variant5Version0() throws java.io.IOException, FiscalException
    8Ch (140) STORAGE OF THE CLIENT'S DATA IN THE MEMORY OF FD Read data for the next client stored in the device's memory.
    Specified by:
      `command140Variant5Version0` in class `FiscalDeviceV1`
    Returns:
      ErrCode - One byte error code. 'P' - Successful execution. 'F' - Error.
    Throws:
      `java.io.IOException`
      `FiscalException`

  - ### command140Variant6Version0

    public FiscalResponse command140Variant6Version0() throws java.io.IOException, FiscalException
    8Ch (140) STORAGE OF THE CLIENT'S DATA IN THE MEMORY OF FD Delete data for all clients stored in the device's memory.
    Specified by:
      `command140Variant6Version0` in class `FiscalDeviceV1`
    Returns:
      ErrCode - One byte error code. 'P' - Successful execution. 'F' - Error.
    Throws:
      `java.io.IOException`
      `FiscalException`

  - ### command140Variant7Version0

    public FiscalResponse command140Variant7Version0​(java.lang.String EIK) throws java.io.IOException, FiscalException
    8Ch (140) STORAGE OF THE CLIENT'S DATA IN THE MEMORY OF FD Read customer data by EIK (UIC).
    Specified by:
      `command140Variant7Version0` in class `FiscalDeviceV1`
    Returns:
      ErrCode - One byte error code. 'P' - Successful execution. 'F' - Error.
    Throws:
      `java.io.IOException`
      `FiscalException`

  - ### getMaxLogoHeightPixel

    public int getMaxLogoHeightPixel()
    Specified by:
      `getMaxLogoHeightPixel` in class `FiscalDeviceV1`

  - ### getMaxLogoWidthPixel

    public int getMaxLogoWidthPixel()
    Specified by:
      `getMaxLogoWidthPixel` in class `FiscalDeviceV1`

  - ### getLogoROW_NUM

    public int getLogoROW_NUM()
    Specified by:
      `getLogoROW_NUM` in class `FiscalDeviceV1`

  - ### getCapFontSupported

    public boolean getCapFontSupported()
    Specified by:
      `getCapFontSupported` in class `FiscalDeviceV1`

  - ### getCapAutoCutter

    public boolean getCapAutoCutter()
    Specified by:
      `getCapAutoCutter` in class `FiscalDeviceV1`

  - ### getPrintColumns

    public int getPrintColumns()
    Specified by:
      `getPrintColumns` in class `FiscalDeviceV1`

  - ### getMaxBarcodeHeight_mm

    public int getMaxBarcodeHeight_mm()
    Specified by:
      `getMaxBarcodeHeight_mm` in class `FiscalDeviceV1`

  - ### getMinBarcodeHeight_mm

    public int getMinBarcodeHeight_mm()
    Specified by:
      `getMinBarcodeHeight_mm` in class `FiscalDeviceV1`